package editeurarbre.ihmediteurarbre;

import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.Action;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JToggleButton;
import javax.swing.JOptionPane;
import java.awt.Component;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.ActionEvent;


public class ToolBarEditeurArbre extends JToolBar implements MouseListener
{
	private final static String NOM_BOUTON_NOUVEAU="nouveau";
	private final static String NOM_BOUTON_SUPPR="suppr";
	private final static String NOM_BOUTON_UNDO="undo";
	
	private Action sonBoutonNouveau=new ToolBarAction(
							new ImageIcon(editeurarbre.ihmediteurarbre.Constantes.NOM_IMAGE_NOUVEAU), 
							Constantes.TOOLTIP_NOUVEAU, NOM_BOUTON_NOUVEAU);
	private Action sonBoutonSuppr=new ToolBarAction(
							new ImageIcon(editeurarbre.ihmediteurarbre.Constantes.NOM_IMAGE_SUPPR), 
							Constantes.TOOLTIP_SUPPR, NOM_BOUTON_SUPPR);
	private Action sonBoutonUndo=new ToolBarAction(
							new ImageIcon(editeurarbre.ihmediteurarbre.Constantes.NOM_IMAGE_UNDO), 
							Constantes.TOOLTIP_ANNULER, NOM_BOUTON_UNDO);
	
	private final String saChaineTousAucun="Tous/Aucun";
	private JCheckBox sonBoutonTousAucun=new JCheckBox(saChaineTousAucun);
	
	private FenetreEditeurArbre saFenetreEditeurArbre=null;
	
	
	public ToolBarEditeurArbre(FenetreEditeurArbre telleFenetreEditeurArbre)
	{
		saFenetreEditeurArbre=telleFenetreEditeurArbre;
		
		sonBoutonTousAucun.addActionListener(new ToolBarAction());

		super.add(sonBoutonTousAucun);
		super.addSeparator();
		super.add(sonBoutonNouveau);
		super.add(sonBoutonSuppr);
		super.add(sonBoutonUndo);
		
		sonBoutonSuppr.setEnabled(false);
		init();
		
		//super.setRollover(true);
		super.setFloatable(false);
		
		removeFocusPainting();
	}
	
	public void init()
	{
		sonBoutonUndo.setEnabled(false);
	}
	
	private void removeFocusPainting()
	{
		Component[] lesComposants=super.getComponents();
		
		for(int i=0; i<lesComposants.length; i++)
		{
			if(lesComposants[i] instanceof JButton)
			{
				((JButton)lesComposants[i]).setFocusPainted(false);
				((JButton)lesComposants[i]).setBorderPainted(false);
				((JButton)lesComposants[i]).addMouseListener(this);
			}
			else
			{
				if(lesComposants[i] instanceof JToggleButton)
				{
					((JToggleButton)lesComposants[i]).setFocusPainted(false);
					((JToggleButton)lesComposants[i]).setBorderPainted(false);
				}
			}
		}
	}
	
	public void setUndoEnabled(boolean telB)
	{
		sonBoutonUndo.setEnabled(telB);
	}
	
	public void setSupprEnabled(boolean telB)
	{
		sonBoutonSuppr.setEnabled(telB);
	}
	
	public void setTousAucunEnabled(boolean telB)
	{
		if(!telB)
		{
			sonBoutonTousAucun.setSelected(false);
			sonBoutonSuppr.setEnabled(false);
		}
		
		sonBoutonTousAucun.setEnabled(telB);
	}
	
	public void setTousAucunSelected(boolean telB)
	{
		sonBoutonTousAucun.setSelected(telB);
	}
	
	public void mouseReleased(MouseEvent e){}
	public void mousePressed(MouseEvent e){}
	public void mouseClicked(MouseEvent e){}
	
	public void mouseExited(MouseEvent e)
	{
		Object laSource = e.getSource();
		
		if(laSource instanceof JButton)
		{
			((JButton)laSource).setBorderPainted(false);
			return;
		}

		if(laSource instanceof JToggleButton)
		{
			((JToggleButton)laSource).setBorderPainted(false);
			return;
		}
	}
	
	public void mouseEntered(MouseEvent e)
	{
		Object laSource = e.getSource();
		
		if(laSource instanceof JButton)
		{
			JButton leBouton = ((JButton)laSource);
			if(leBouton.isEnabled())
			{
				leBouton.setBorderPainted(true);
			}
			return;
		}

		if(laSource instanceof JToggleButton)
		{
			if(((JToggleButton)laSource).isEnabled())
			{
				((JToggleButton)laSource).setBorderPainted(true);
			}
			return;
		}
	}	
	
	
	
	private class ToolBarAction extends AbstractAction
	{
		private static final String NOM="nom";
		
		public ToolBarAction(Icon telleIcon, String telleDesc, String telNom)
		{
			super.putValue(Action.NAME, "");
			super.putValue(Action.SMALL_ICON, telleIcon);
			super.putValue(Action.SHORT_DESCRIPTION, telleDesc);
			super.putValue(NOM, telNom);
		}
		
		public ToolBarAction(){}
		
		public void actionPerformed(ActionEvent e)
		{
			if(e.getSource() instanceof JCheckBox)
			{
				if(e.getSource()==sonBoutonTousAucun)
				{
					if(sonBoutonTousAucun.isSelected())
						saFenetreEditeurArbre.selectAll();
					else
						saFenetreEditeurArbre.deselectAll();
				}
			}
			else
			{
				String leNom=(String)getValue(NOM);
				if(leNom.equals(NOM_BOUTON_NOUVEAU))
				{
					saFenetreEditeurArbre.ajouteLigneTableau();
				}
				else
				{
					if(leNom.equals(NOM_BOUTON_SUPPR))
					{
						int leNb=saFenetreEditeurArbre.getNbLignesTableau();
						boolean ok=false;
						
						for(int i=0; i<leNb && !ok; i++)
						{
							if(saFenetreEditeurArbre.isSelected(i))
								ok=true;
						}
						
						
						int leRes=0;
						if(ok)
							leRes=JOptionPane.showConfirmDialog(saFenetreEditeurArbre, "Etes-vous sr(e) de vouloir supprimer ce(s) enregistrement(s)?", "Confirmation", JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
							
						if(leRes==JOptionPane.OK_OPTION)
						{
							// suppression de tous les elts selectionnes
							for(int i=0; i<saFenetreEditeurArbre.getNbLignesTableau(); i++)
							{
								
								if(saFenetreEditeurArbre.isSelected(i))
								{
									boolean reussi=saFenetreEditeurArbre.retireLigneTableau(i);
									if(reussi)
										i--;
								}
							}//for
							
							//le bouton suppr est inutile, on le desactive
							saFenetreEditeurArbre.changementColSupprTable(editeurarbre.Constantes.SUPPR);
							
							//apres la suppression, on verifie l etat des differents boutons
							saFenetreEditeurArbre.verifieEtatBoutons();
						}//if
					}//if
					else
					{
						if(leNom.equals(NOM_BOUTON_UNDO))
						{
							saFenetreEditeurArbre.actionBoutonUndo();
						}
					}
				}//else
			}//else
		}//actionPerformed
	}//class
	
}//class