package moduleaide;

import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.io.*;
import java.awt.event.*;
import ihm.*;

public class FenetreAide extends JDialog
{
	private JTabbedPane sonOnglet = new JTabbedPane();
	private JTextArea[] lesTextes=new JTextArea[6];
    private JScrollPane[] lesBarres=new JScrollPane[6];

	public FenetreAide(IHM telleIHM)
	{
		super(telleIHM, "Aide");
		
		sonOnglet.setFont(Constantes.POLICE);

        addWindowListener(new WindowAdapter()
         {public void windowClosing(WindowEvent e)
          {try{FermetureFenetre();}
          catch(java.lang.Exception a){};
          }});

        // corps des onglets:
        for(int i=0;i<lesTextes.length;i++)
		{
         // champ du texte:
         lesTextes[i]=new JTextArea();
         lesTextes[i].setLineWrap(true);
         // barre de defilement:
         lesBarres[i]=new JScrollPane(lesTextes[i],JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

        }

        // creation des onglets:
        sonOnglet.addTab(ConstantesAide.TITRE_ONGLET_0,new ImageIcon(ConstantesAide.IMAGE_ONGLET_0),lesBarres[0]);
        sonOnglet.addTab(ConstantesAide.TITRE_ONGLET_1,new ImageIcon(ConstantesAide.IMAGE_ONGLET_1),lesBarres[1]);
        sonOnglet.addTab(ConstantesAide.TITRE_ONGLET_2,new ImageIcon(ConstantesAide.IMAGE_ONGLET_2),lesBarres[2]);
        sonOnglet.addTab(ConstantesAide.TITRE_ONGLET_3,new ImageIcon(ConstantesAide.IMAGE_ONGLET_3),lesBarres[3]);
        sonOnglet.addTab(ConstantesAide.TITRE_ONGLET_4,new ImageIcon(ConstantesAide.IMAGE_ONGLET_4),lesBarres[4]);
        sonOnglet.addTab(ConstantesAide.TITRE_ONGLET_5,new ImageIcon(ConstantesAide.IMAGE_ONGLET_5),lesBarres[5]);

        // remplissage du texte:
		lesTextes[0].setText(LireFichier(ConstantesAide.FICHIER_TEXTE_ONGLET_0));
        lesTextes[1].setText(LireFichier(ConstantesAide.FICHIER_TEXTE_ONGLET_1));
        lesTextes[2].setText(LireFichier(ConstantesAide.FICHIER_TEXTE_ONGLET_2));
        lesTextes[3].setText(LireFichier(ConstantesAide.FICHIER_TEXTE_ONGLET_3));
        lesTextes[4].setText(LireFichier(ConstantesAide.FICHIER_TEXTE_ONGLET_4));
        lesTextes[5].setText(LireFichier(ConstantesAide.FICHIER_TEXTE_ONGLET_5));

         for(int i = 0; i<5; i++)
         {
         	lesTextes[i].setEditable(false);
         	lesTextes[i].setCaretPosition(0);
         	
         }

		// Affiche le 1er onglet
		sonOnglet.setSelectedIndex(0);
		getContentPane().add(sonOnglet);
		
		
		setSize(600,440);
		setLocationRelativeTo(telleIHM);
		setVisible(true);
	}

  	public String LireFichier(String NomFichier) //throws Exception
    {
    	try
    	{
    		FileReader filereader=new FileReader(NomFichier);
     		char data[]=new char[50000];
     		int charsread=filereader.read(data);
     		String texte=new String(data,0,charsread);
     		filereader.close();
     		return texte;
     	}
     	catch(IOException e)
     	{
     		e.printStackTrace();	
     	}
     	return "";
    }

    public void FermetureFenetre()
    {
    	try
    	{
    		// on enregistre les bloc note dans le fichier:
     		FileWriter filewriter=new FileWriter(ConstantesAide.FICHIER_TEXTE_ONGLET_5);
     		filewriter.write(lesTextes[5].getText());
     		filewriter.close();
     	}
     	catch(IOException e)
     	{
     		e.printStackTrace();	
     	}
    }

}
