package modulecreation;

import javax.swing.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;

import structuresgraphique.UnArbreGraphique;
import ihm.*;

class UnPanelCommandesDessin extends JPanel implements ActionListener, MouseListener, Runnable
{
	// Les diffrents boutons
	private JButton sonBoutonNouveau    = new JButton(ConstantesCreation.TEXTE_NOUVEAU,  new ImageIcon(ConstantesCreation.IMG_NEW));
	private JButton sonBoutonFermer     = new JButton(ConstantesCreation.TEXTE_FERMER,   new ImageIcon(ConstantesCreation.IMG_CLOSE));
	private JButton sonBoutonPremier    = new JButton(ConstantesCreation.TEXTE_PREMIER,  new ImageIcon(ConstantesCreation.IMG_FIRST));
	private JButton sonBoutonPrecedent  = new JButton(ConstantesCreation.TEXTE_PRECEDENT,new ImageIcon(ConstantesCreation.IMG_PREV));
	private JButton sonBoutonSuivant    = new JButton(ConstantesCreation.TEXTE_SUIVANT,  new ImageIcon(ConstantesCreation.IMG_NEXT));
	private JButton sonBoutonDernier    = new JButton(ConstantesCreation.TEXTE_DERNIER,  new ImageIcon(ConstantesCreation.IMG_LAST));
	private JButton sonBoutonAnnuler    = new JButton(ConstantesCreation.TEXTE_ANNULER,  new ImageIcon(ConstantesCreation.IMG_UNDO) );
	private JButton sonBoutonUnzoom     = new JButton(new ImageIcon(ConstantesCreation.IMG_UNZOOM) );
	private JButton sonBoutonZoom       = new JButton(new ImageIcon(ConstantesCreation.IMG_ZOOM)   );
	private JToggleButton sonBoutonFils = new JToggleButton(ConstantesCreation.TEXTE_FILS, new ImageIcon(ConstantesCreation.IMG_FILS));
	
	// Le panel qui a comme layout le cardlayout
	private JPanel sonPanelCartes;
	
	// Le panel actif du card layout
	private UnPanelDessin sonPanelDessinActif = null;
	
	// Le numero du panel courant
	private int sonNumPanelCourant=1;
	
	// Le label qui affiche l'arbre courant et le nombre d'arbre
	private JLabel sonLabelNbPanel;
	
	// Le panel Source
	private UnPanelDessinBase sonPanelDessinAll = null;
	
	private Dimension saDimensionLabel = new Dimension(70,20);

	/**
	 * Construit le panel de commande
	 * @param telPanelCartes le panel qui est en card layout
	 * @param telPanelDessinAll le panel qui contient les arbres ...
	 */
	public UnPanelCommandesDessin(JPanel telPanelCartes, UnPanelDessinBase telPanelDessinAll)
	{
		super(new FlowLayout(FlowLayout.CENTER, 0, 0));
		
		sonPanelCartes = telPanelCartes;
		sonPanelDessinAll = telPanelDessinAll;
		
		// Le bouton nouvel arbre
		sonBoutonNouveau.setBorderPainted(false);
		sonBoutonNouveau.setToolTipText(ConstantesCreation.TOOLTIP_NOUVEAU);
		sonBoutonNouveau.setFocusPainted(false);
		sonBoutonNouveau.addActionListener(this);
		sonBoutonNouveau.addMouseListener(this);
		sonBoutonNouveau.setFont(Constantes.POLICE);
		sonBoutonNouveau.setMargin(new Insets(0,0,0,10));

		// Le bouton fermer arbre
		sonBoutonFermer.setBorderPainted(false);
		sonBoutonFermer.setToolTipText(ConstantesCreation.TOOLTIP_FERMER);
		sonBoutonFermer.setFocusPainted(false);
		sonBoutonFermer.addActionListener(this);
		sonBoutonFermer.addMouseListener(this);
		sonBoutonFermer.setFont(Constantes.POLICE);
		sonBoutonFermer.setMargin(new Insets(0,0,0,10));
		
		// Bouton Fils
		sonBoutonFils.setBorderPainted(false);
		sonBoutonFils.setToolTipText(ConstantesCreation.TOOLTIP_FILS);
		sonBoutonFils.setFocusPainted(false);
		sonBoutonFils.addActionListener(this);
		sonBoutonFils.addMouseListener(this);
		sonBoutonFils.setFont(Constantes.POLICE);
		sonBoutonFils.setMargin(new Insets(0,0,0,10));
		
		//	Bouton Premier
		sonBoutonPremier.setBorderPainted(false);
		sonBoutonPremier.setToolTipText(ConstantesCreation.TOOLTIP_PREMIER);
		sonBoutonPremier.setFocusPainted(false);
		sonBoutonPremier.addActionListener(this);
		sonBoutonPremier.addMouseListener(this);
		sonBoutonPremier.setFont(Constantes.POLICE);
		sonBoutonPremier.setMargin(new Insets(0,0,0,10));
		
		//	Bouton Prcdent
		sonBoutonPrecedent.setBorderPainted(false);
		sonBoutonPrecedent.setToolTipText(ConstantesCreation.TOOLTIP_PRECEDENT);
		sonBoutonPrecedent.setFocusPainted(false);
		sonBoutonPrecedent.addActionListener(this);
		sonBoutonPrecedent.addMouseListener(this);
		sonBoutonPrecedent.setFont(Constantes.POLICE);
		sonBoutonPrecedent.setMargin(new Insets(0,0,0,10));
		
		//	Bouton suivant
		sonBoutonSuivant.setBorderPainted(false);
		sonBoutonSuivant.setToolTipText(ConstantesCreation.TOOLTIP_SUIVANT);
		sonBoutonSuivant.setFocusPainted(false);
		sonBoutonSuivant.setHorizontalTextPosition(JButton.LEFT);
		sonBoutonSuivant.addActionListener(this);
		sonBoutonSuivant.addMouseListener(this);
		sonBoutonSuivant.setFont(Constantes.POLICE);
		sonBoutonSuivant.setMargin(new Insets(0,0,0,10));
		
		// Bouton dernier
		sonBoutonDernier.setBorderPainted(false);
		sonBoutonDernier.setToolTipText(ConstantesCreation.TOOLTIP_DERNIER);
		sonBoutonDernier.setFocusPainted(false);
		sonBoutonDernier.setHorizontalTextPosition(JButton.LEFT);
		sonBoutonDernier.addActionListener(this);
		sonBoutonDernier.addMouseListener(this);
		sonBoutonDernier.setFont(Constantes.POLICE);
		sonBoutonDernier.setMargin(new Insets(0,0,0,10));
		
		// Bouton annuler
		sonBoutonAnnuler.setBorderPainted(false);
		sonBoutonAnnuler.setToolTipText(ConstantesCreation.TOOLTIP_ANNULER);
		sonBoutonAnnuler.setFocusPainted(false);
		sonBoutonAnnuler.setHorizontalTextPosition(JButton.RIGHT);
		sonBoutonAnnuler.addActionListener(this);
		sonBoutonAnnuler.addMouseListener(this);
		sonBoutonAnnuler.setFont(Constantes.POLICE);
		sonBoutonAnnuler.setMargin(new Insets(0,0,0,10));	

		// Bouton unzoom
		sonBoutonUnzoom.setBorderPainted(false);
		sonBoutonUnzoom.setToolTipText(ConstantesCreation.TOOLTIP_UNZOOM);
		sonBoutonUnzoom.setFocusPainted(false);
		sonBoutonUnzoom.addActionListener(this);
		sonBoutonUnzoom.addMouseListener(this);
		sonBoutonUnzoom.setFont(Constantes.POLICE);
		sonBoutonUnzoom.setMargin(new Insets(0,0,0,0));	
				
		// Bouton Zoom
		sonBoutonZoom.setBorderPainted(false);
		sonBoutonZoom.setToolTipText(ConstantesCreation.TOOLTIP_ZOOM);
		sonBoutonZoom.setFocusPainted(false);
		sonBoutonZoom.addActionListener(this);
		sonBoutonZoom.addMouseListener(this);
		sonBoutonZoom.setFont(Constantes.POLICE);
		sonBoutonZoom.setMargin(new Insets(0,0,0,0));		
		
		// Le label qui affiche le nombre d'arbre
		sonLabelNbPanel = new JLabel();
		sonLabelNbPanel.setMaximumSize(saDimensionLabel);
		sonLabelNbPanel.setPreferredSize(saDimensionLabel);
		sonLabelNbPanel.setFont(Constantes.POLICE);
		
		// Ajout des lments au panel
		add(sonBoutonNouveau);
		add(sonBoutonFermer);
		add(sonBoutonFils);
		add(sonBoutonAnnuler);
		add(sonBoutonPremier);
		add(sonBoutonPrecedent);
		add(sonBoutonSuivant);
		add(sonBoutonDernier);
		add(sonBoutonUnzoom);
		add(sonBoutonZoom);
		add(sonLabelNbPanel);
		
		/* Dsactivation de tous les boutons inutiles */
		activeBouton ();
		
		Thread leThread = new Thread(this);
		leThread.start();
		
	}	

	/* efface le panel excution en cas de modification de l'arbre en cours */
	private void efface ()
	{
		sonPanelDessinAll.getPere ().efface_exec ();
	}

	public void actionPerformed(ActionEvent e)
	{
		Object obj = e.getSource();
		
		// Creer un fils
		if(obj == sonBoutonFils)
		{
			efface ();
			verifieFils();
			return;
		}

		// Affiche le 1er panel
		if(obj == sonBoutonPremier)
		{
			efface ();
			premierPanel();
			return;		
		}

		// Affiche le dernier panel
		if(obj == sonBoutonPrecedent)
		{
			efface ();
			panelPrecedent();
			return;
		}
		
		// Affiche le panel suivant		
		if(obj == sonBoutonSuivant)
		{
			efface ();
			panelSuivant();			
			return;
		}
		
		// Affiche le panel suivant
		if(obj == sonBoutonDernier)
		{
			efface ();
			dernierPanel();
			return;
		}	
		
		// Cre et affiche un nouveau panel
		if(obj == sonBoutonNouveau)
		{
			efface ();
			nouveauPanel();
			return;			
		}
		
		// Fermer le panel courant
		if(obj == sonBoutonFermer)
		{
			efface ();
			fermerPanel();
			return;
		}
		
		// Zoom
		if(obj == sonBoutonZoom)
		{
			ConstantesCreation.SCALE+=0.1d;
			sonBoutonUnzoom.setEnabled(true);
			
			if(ConstantesCreation.SCALE >= ConstantesCreation.MAX_SCALE)
			{
				sonBoutonZoom.setEnabled(false);
				sonBoutonZoom.setBorderPainted(false);
			}	
			
			sonPanelDessinAll.repaintAll();
			return;
		}
		
		if(obj == sonBoutonUnzoom)
		{
			ConstantesCreation.SCALE-=0.1d;
			sonBoutonZoom.setEnabled(true);
			
			if(ConstantesCreation.SCALE <= ConstantesCreation.MIN_SCALE)
			{
				sonBoutonUnzoom.setEnabled(false);
				sonBoutonUnzoom.setBorderPainted(false);
			}
			
			sonPanelDessinAll.repaintAll();
			return;
		}
		
		// Annulation
		if(obj == sonBoutonAnnuler)
		{
			efface ();
			getSaScrollBar().getSonPanel().doUndo();
			updateUI();
			return;	
		}
	}
	
	/**
	 * Creer un nouveau panel avec un arbre vierge
	 * le panel est cre en dernire position
	 */
	public void nouveauPanel()
	{
		sonPanelDessinAll.addNewPanel();
		sonBoutonFermer.setEnabled(true);
		sonBoutonFils.setEnabled(true);
		dernierPanel();
		
		if(ConstantesCreation.SCALE <= ConstantesCreation.MAX_SCALE)
			sonBoutonZoom.setEnabled(true);
		
		if(ConstantesCreation.SCALE >= ConstantesCreation.MIN_SCALE)
			sonBoutonUnzoom.setEnabled(true);
	}
	
	/**
	 * Creer un nouveau panel avec un arbre vierge
	 * le panel est cre en dernire position
	 */
	public void nouveauPanel2()
	{
		sonBoutonFermer.setEnabled(true);
		sonBoutonFils.setEnabled(true);
		dernierPanel();
		
		if(ConstantesCreation.SCALE <= ConstantesCreation.MAX_SCALE)
			sonBoutonZoom.setEnabled(true);
		
		if(ConstantesCreation.SCALE >= ConstantesCreation.MIN_SCALE)
			sonBoutonUnzoom.setEnabled(true);
	}
	
	
	/**
	 * Active ou non certains boutons
	 */
	public void activeBouton()
	{
		// Il n'y a plus aucun panel
		if(sonPanelCartes.getComponentCount() == 0)
		{
			sonBoutonFermer.setEnabled(false);
			sonBoutonFermer.setBorderPainted(false);
			
			sonBoutonFils.setSelected(false);
			sonBoutonFils.setBorderPainted(false);
			sonBoutonFils.setEnabled(false);
			
			sonBoutonPremier.setEnabled(false);
			sonBoutonPremier.setBorderPainted(false);
			
			sonBoutonSuivant.setEnabled(false);
			sonBoutonSuivant.setBorderPainted(false);
						
			sonBoutonPrecedent.setEnabled(false);
			sonBoutonPrecedent.setBorderPainted(false);
			
			sonBoutonDernier.setEnabled(false);
			sonBoutonDernier.setBorderPainted(false);	
			
			sonBoutonAnnuler.setEnabled(false);
			sonBoutonAnnuler.setBorderPainted(false);
			
			sonBoutonUnzoom.setEnabled(false);
			sonBoutonUnzoom.setBorderPainted(false);
			
			sonBoutonZoom.setEnabled(false);
			sonBoutonZoom.setBorderPainted(false);
			
			return;
		}
	
		// Le panel courant est le 1er
		if(sonNumPanelCourant == 1)
		{
			sonBoutonPremier.setEnabled(false);
			sonBoutonPremier.setBorderPainted(false);
						
			sonBoutonPrecedent.setEnabled(false);
			sonBoutonPrecedent.setBorderPainted(false);	
			
			// Il y a d'autres panels aprs le 1er
			if(sonPanelCartes.getComponentCount() > 1)
			{
				sonBoutonSuivant.setEnabled(true);
				sonBoutonDernier.setEnabled(true);			
			}
			else
			{
				sonBoutonSuivant.setEnabled(false);
				sonBoutonSuivant.setBorderPainted(false);
				sonBoutonDernier.setEnabled(false);
				sonBoutonDernier.setBorderPainted(false);				
			}
			
			return;			
		}
		
		// Le panel courant est le dernier (et donc pas le 1er car
		// il ne peut pas tre seul)
		if(sonNumPanelCourant == sonPanelCartes.getComponentCount())
		{
			sonBoutonSuivant.setEnabled(false);
			sonBoutonSuivant.setBorderPainted(false);
			sonBoutonDernier.setEnabled(false);
			sonBoutonDernier.setBorderPainted(false);
			
			sonBoutonPremier.setEnabled(true);
			sonBoutonPrecedent.setEnabled(true);
			
			return;			
		}

		// Le panel courant n'est ni le 1er, ni le dernier
		if(sonNumPanelCourant>1 && sonNumPanelCourant < sonPanelCartes.getComponentCount())
		{
			sonBoutonPremier.setEnabled(true);
			sonBoutonSuivant.setEnabled(true);
			sonBoutonPrecedent.setEnabled(true);
			sonBoutonDernier.setEnabled(true);
			return;		
		}
	}

	/**
	 * Ferme le panel courant
	 */
	public void fermerPanel()
	{
		sonPanelCartes.remove(getSaScrollBar());
		sonPanelCartes.updateUI();
		
		if(sonNumPanelCourant == 1 && sonPanelCartes.getComponentCount() !=0)
			majLabelNbArbre(sonNumPanelCourant);
		else
			majLabelNbArbre(sonNumPanelCourant-1);
		
		activeBouton();
	}
	
	/**
	 * Affiche le 1er panel
	 */
	public void premierPanel()
	{
		((CardLayout)sonPanelCartes.getLayout()).first(sonPanelCartes);
		verifieFils();
			
		majLabelNbArbre(1);
		activeBouton();
	}

	/**
	 * Affiche le panel prcdent le panel courant
	 */
	public void panelPrecedent()
	{
		((CardLayout)sonPanelCartes.getLayout()).previous(sonPanelCartes);
		verifieFils();
			
		majLabelNbArbre(sonNumPanelCourant-1);
		activeBouton();
	}

	
	/**
	 * Affiche le panel suivant le panel courant
	 */
	public void panelSuivant()
	{
		((CardLayout)sonPanelCartes.getLayout()).next(sonPanelCartes);
		verifieFils();	
			
		sonBoutonPremier.setEnabled(true);
		sonBoutonPrecedent.setEnabled(true);
			
		majLabelNbArbre(sonNumPanelCourant+1);
		activeBouton();		
	}
	
	/**
	 * Affiche le dernier panel
	 */
	public void dernierPanel()
	{
		((CardLayout)sonPanelCartes.getLayout()).last(sonPanelCartes);
		verifieFils();
			
		majLabelNbArbre(sonPanelCartes.getComponentCount());
		activeBouton();
		
	}
	
	/**
	 * Verifie quand un nouveau panel est activ si le bouton
	 * de cration d'un fils doit tre activ
	 */
	public void verifieFils()
	{
		sonPanelDessinActif = getSaScrollBar().getSonPanel();
		if(sonBoutonFils.isSelected())
			sonPanelDessinActif.createFils();
		else
			sonPanelDessinActif.noCreation();

	}
	
	public UneScrollbar getSaScrollBar()
	{
		try
		{
			if(sonPanelCartes!=null && sonPanelCartes.findComponentAt(new Point(0,0)) != null)
				return 	((UneScrollbar)sonPanelCartes.findComponentAt(new Point(0,0)));
		}
		catch(ClassCastException e){}
		return null;
	}
	
	/**
	 * Met  jour le label qui affiche l'arbre courant
	 * et le nombre d'arbres
	 */
	public void majLabelNbArbre(int nouveauNbPanelCourant)
	{
		sonNumPanelCourant=nouveauNbPanelCourant;
		sonLabelNbPanel.setText(nouveauNbPanelCourant + " / " + sonPanelCartes.getComponentCount());
	}
	
	public void mouseReleased(MouseEvent e){}
	public void mousePressed(MouseEvent e){}
	public void mouseClicked(MouseEvent e){}
	
	public void mouseExited(MouseEvent e)
	{
		Object laSource = e.getSource();
		
		if(laSource instanceof JButton)
		{
			((JButton)laSource).setBorderPainted(false);
			return;
		}

		if(laSource instanceof JToggleButton)
		{
			((JToggleButton)laSource).setBorderPainted(false);
			return;
		}
	}
	
	public void mouseEntered(MouseEvent e)
	{
		Object laSource = e.getSource();
		
		if(laSource instanceof JButton)
		{
			JButton leBouton = ((JButton)laSource);
			if(leBouton.isEnabled())
			{
				leBouton.setBorderPainted(true);
			}
			return;
		}

		if(laSource instanceof JToggleButton)
		{
			if(((JToggleButton)laSource).isEnabled())
			{
				((JToggleButton)laSource).setBorderPainted(true);
			}
			return;
		}
	}
	
	public void run()
	{
		while(true)
		{
			if(getSaScrollBar() != null)
			{
				sonBoutonAnnuler.setEnabled(getSaScrollBar().getSonPanel().getUndoState());
				if(getSaScrollBar().getSonPanel().getUndoState() == false)
				{
					sonBoutonAnnuler.setBorderPainted(false);
				}
			}
			
			try
			{
				Thread.sleep(100);
			}
			catch(InterruptedException e)
			{
				e.printStackTrace();	
			}
		}
	}
	
}
