package moduleexecution;

import structuresgraphique.UnArbreGraphique;
import structuresdonnees.*;
import conversion.*;
import structuresgraphique.UneCourbe;
import java.util.Vector;



/* ---------------------------------------------------------- */
/* Classe contenant les actions possibles du module execution */
/* ---------------------------------------------------------- */

public class ActionsExecution {
	
	private PanneauExecution sonModuleExecution;

	/* permet d'arrter un thread d'affichage quand on switch
	 * sur un nouvel ordo */
	private UnThread est_lance;
	
	public ActionsExecution(PanneauExecution telPE) {
		
		sonModuleExecution = telPE;
	}

	/* Mthodes Afficher / Masquer Rapport */
	public void action_MasquerPanneauRapport() { sonModuleExecution.getPanneauAffichage().getPanneauInfosTrace().setVisible(false);}	
	public void action_AfficherPanneauRapport() {sonModuleExecution.getPanneauAffichage().getPanneauInfosTrace().setVisible(true);}

	/* Lance l'algorithme pass en paramtre */
	public void action_lancerExecutionAlgo(int telAlgo) {
		UnArbreGraphique ABRGraphique;
		ABP ABRDonnee;
		Lanceur unLanceur;
		sonModuleExecution.getPanneauAffichage().afficherInfos("Recuperation des donnees:");	
		/* Rcuprer l'ABR */
		ABRGraphique = sonModuleExecution.getPanneauAffichage().getPanelArbre().getArbre();
		if ( ABRGraphique == null) {
			sonModuleExecution.getPanneauAffichage().afficherInfos("   Erreur de recuperation de l'ABP!!");
			 sonModuleExecution.getToolBar().activerExecution ();
			return;
		}
		else {
			sonModuleExecution.getPanneauAffichage().afficherInfos("   ABP....ok");	
		}
		/* Gnrer une instance de la structure commune */
		ABRDonnee = Conversion.graphicToDonnees(ABRGraphique);
		if (ABRDonnee == null) {
			sonModuleExecution.getPanneauAffichage().afficherInfos("   Erreur de conversion de l'ABP!!");
			sonModuleExecution.getToolBar().activerExecution ();
			return;		
			
		}
		else {
			sonModuleExecution.getPanneauAffichage().afficherInfos("   Conversion ABP....ok");	
		}
		/* Instance du Thread qui va lancer l'algo */
		unLanceur = new Lanceur(sonModuleExecution);
		sonModuleExecution.setLanceur(unLanceur);
		sonModuleExecution.getLanceur().setPriority(Thread.MIN_PRIORITY);
		sonModuleExecution.getLanceur().setNumAlgo(telAlgo);
		sonModuleExecution.getLanceur().setABRDonnee(ABRDonnee);
		sonModuleExecution.getLanceur().start();	
	} // fin de action_lancerExecutionAlgo
	
	/* Stoppe l'execution de l'algorithme pass en paramtre */
	public void action_stopperExecutionAlgo() {
		sonModuleExecution.getPanneauAffichage().afficherInfos(Constantes.MSG_RAPPORT_ARRET_ALGO);
		sonModuleExecution.getLanceur ().arret ();
		sonModuleExecution.getPanneauAffichage().getPanelArbre().getSonArbre().maj_x_y();
		sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
	}// fin de action_lancerExecutionAlgo
	
	
	/* Affiche l'ordonnancement suivant avec sa courbe */
	public void action_miseAJourOrdonnancement() {
		try {
			Vector res = sonModuleExecution.getPanneauAffichage().getPanelCourbe().getOrdonnancement();
			int k = sonModuleExecution.getPanneauAffichage().getPanelCourbe().getIndiceOrdonnancement();
		
			/* Afficher l'ordonnancement i+1 ou i+1 de la liste */
			String s="";
			for(int i=0; i<(((Ordonnancement)res.elementAt(k)).getEtape()).length; i++){
				s+=(((Ordonnancement)res.elementAt(k)).getEtape())[i][0]+" ";
			}
			/* Rechercher la position ds le JTextArea */
			String ch = sonModuleExecution.getPanneauAffichage().getZoneRapport().getText();
			String ch2 = "Ordo["+(k+1)+"-"+sonModuleExecution.getPanneauAffichage().getPanelCourbe().getOrdonnancement().size()+"] : "+s;
			int i = ch.length()-2;
			/* petite astuce pour avoir un affichage correct mme si on
			 * la mention algo arrt qui pourrai dcaler l'affichage */
			int j = 1;
			if (Usine.continu ()) j--;
			Usine.debut ();
			for (int l = 0; l <= j; l++) {
				while (ch.charAt(i) != '\n') i--;
				i--;
			}
			i++;
			/* fin de l'astuce */
			sonModuleExecution.getPanneauAffichage().getZoneRapport().replaceRange(ch2, (i+1), (ch.length()-1));
			
			sonModuleExecution.getPanneauAffichage().getPanelCourbe().setCourbe(new UneCourbe(((Ordonnancement)res.elementAt(k)),sonModuleExecution.getLanceur().getABP(),880,595));
			/* on affiche le pas  pas si c'est le mode pas  pas ... */
			if (sonModuleExecution.getToolBar().isPasapas()) {
				sonModuleExecution.getToolBar().activerStop ();
				sonModuleExecution.getLanceur().indice = k;
				est_lance = new UnThread(sonModuleExecution,res,k);
				est_lance.start ();
			}
		}	
		catch(Exception ex) {System.out.println("ERREUR ds action_miseAJourOrdonnancement()");}
	} // fin de action_gererResultat
	
	
}

class UnThread extends Thread
{
	int sonK;
	Vector sonRes;
	PanneauExecution sonExec;
	
	public UnThread(PanneauExecution telE, Vector telRes, int telK)
	{
		sonExec=telE;
		sonRes=telRes;
		sonK=telK;
	}	

	public void run()
	{
		sonExec.getLanceur().indice = sonK;
		sonExec.getLanceur().affiche_PAP (sonRes);
		sonExec.getToolBar().activerExecution ();
	}
}
