package moduleexecution;

import java.lang.*;
import java.util.Vector;
import java.awt.Color;

import structuresdonnees.*;
import structuresgraphique.*;
import parametres.Parametrages;


/* --------------------------------------------- */
/*   Classe qui lance les algos dans un Thread   */
/* --------------------------------------------- */

public class Lanceur extends Thread {

	int VITESSE = 500;
	PanneauExecution sonModuleExecution;
	private int sonAlgo;
	private ABP sonABRDonnee;
	private Usine sonUsine; /* Appel lors des appels aux algos du grp 2 */
	
	public Usine getUsine() { return sonUsine;}
	public void setABRDonnee(ABP telArbre) {sonABRDonnee = telArbre;}
	public ABP getABP(){return sonABRDonnee;}
	
	public int indice;
	
	public int getNumAlgo(){return sonAlgo;}
	public void setNumAlgo(int n){sonAlgo = n;}
	
	public Lanceur(PanneauExecution telPE) {
		sonModuleExecution = telPE;
		sonUsine = new Usine();
		
	}

	/* on met ici l'affichage des algos d'ordo
	 * pour la partie commune */
	private void affiche_debut (Vector res)
	{
		String s = "";
		sonModuleExecution.getPanneauAffichage().afficherInfos("   Algo fini....ok");
		/* Grer le resultat */
		sonModuleExecution.getPanneauAffichage().getPanelCourbe().setOrdonnancement(res);
		sonModuleExecution.getPanneauAffichage().getPanelCourbe().setIndiceOrdonnancement(0);
		sonModuleExecution.getPanneauAffichage().getPanelCourbe().setCourbe(new UneCourbe(((Ordonnancement)res.elementAt(0)),sonABRDonnee,880,595));
		
		/* Afficher le 1er ordonnancement de la liste */
		sonModuleExecution.getPanneauAffichage().afficherInfos("Resultat:");
		for(int i=0; i<(((Ordonnancement)res.elementAt(0)).getEtape()).length; i++){
			s+=(((Ordonnancement)res.elementAt(0)).getEtape())[i][0]+" ";
		}
		sonModuleExecution.getPanneauAffichage().afficherInfos("Ordo["+(sonModuleExecution.getPanneauAffichage().getPanelCourbe().getIndiceOrdonnancement()+1)+"-"+sonModuleExecution.getPanneauAffichage().getPanelCourbe().getOrdonnancement().size()+"] : "+s);
		sonModuleExecution.getToolBar().activerNext(false);
		sonModuleExecution.getToolBar().activerPrev(false);
	}

	/* ici, on va afficher un pas  pas en fonction d'un algo et
	 * de l'indice de l'arbre  afficher */
	public void affiche_PAP (Vector res)
	{
		sonModuleExecution.getToolBar().activerNext(false);
		sonModuleExecution.getToolBar().activerPrev(false);
		/* quel algo doit on afficher ? */
		switch (sonAlgo) {
			/* ces deux algos ont le mme mode d'affichage */
			case Constantes.NUM_ALGO_ORDOT_OG :
			case Constantes.NUM_ALGO_ORDO_T :  {
				Ordonnancement ordo = (Ordonnancement) res.elementAt(indice);
				Vector pas_a_pas = ordo.getPas_a_Pas();
				int[][] etape = ordo.getEtape();
				int position = 0;
				int taille = pas_a_pas.size();
				Vector courant = new Vector();
				Vector noeud = new Vector();
				Vector couleurOrigine = new Vector();
				Vector couleur = new Vector();
				UnArbreGraphique arbre = sonModuleExecution.getPanneauAffichage().getPanelArbre().getArbre();
				for(int i=0; i<taille && Usine.continu (); i++) {
					Liste liste = (Liste)pas_a_pas.elementAt(i);
					int fin = liste.size();
					for(int j=0; j<fin; j++) {
						courant.add(arbre.trouveSommet(liste.elementAt(j)));
						couleurOrigine.add(( (UnSommet)courant.lastElement() ).getSaCouleur());
						((UnSommet)courant.lastElement() ).setSaCouleur(Color.yellow);
						sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
					}
					try { Thread.sleep(VITESSE+200); }
					catch (InterruptedException e) {}
					
					for(int k=0; k<courant.size(); k++) {
						UnSommet s = (UnSommet)courant.elementAt(k);
						if(s.getSonId() != etape[position][0])
							s.setSaCouleur((Color)couleurOrigine.elementAt(k));
						else
						{
							noeud.add(s);
							couleur.add((Color)couleurOrigine.elementAt(k));
							s.setSaCouleur(Parametrages.getCoulSelection ());
							position ++;
						}
					}
					sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
					
					courant.removeAllElements();
					couleurOrigine.removeAllElements();
				}
				
				if (!Usine.continu ()) break;
				try { Thread.sleep(VITESSE+200); }
				catch (InterruptedException e) {}
				
				for(int i=0; i<taille; i++)
				{
					UnSommet s  = (UnSommet)noeud.elementAt(i);
					s.setSaCouleur((Color)couleur.elementAt(i));
					sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
				}
			}
			break;
			case Constantes.NUM_ALGO_ORDO_A : {
				Ordonnancement ordo = (Ordonnancement) res.elementAt(indice);
				Vector pas_a_pas = ordo.getPas_a_Pas();
				int[][] etape = ordo.getEtape();
				int position = 0;
				int taille = pas_a_pas.size();
				Vector courant = new Vector();
				Vector noeud = new Vector();
				Vector couleurOrigine = new Vector();
				Vector couleur = new Vector();
				UnArbreGraphique arbre = sonModuleExecution.getPanneauAffichage().getPanelArbre().getArbre();
				for(int i=0; i<taille && Usine.continu (); i++) {
					Vector liste = (Vector)pas_a_pas.elementAt(i);
					int fin = liste.size();
					for(int j=0; j<fin; j++) {
						courant.add(arbre.trouveSommet(((Integer)liste.elementAt(j)).intValue()));
						couleurOrigine.add(( (UnSommet)courant.lastElement() ).getSaCouleur());
						((UnSommet)courant.lastElement() ).setSaCouleur(Color.yellow);
						sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
					}
					try { Thread.sleep(VITESSE+200); }
					catch (InterruptedException e) {}
					
					for(int k=0; k<courant.size(); k++) {
						UnSommet s = (UnSommet)courant.elementAt(k);
						if(s.getSonId() != etape[position][0])
							s.setSaCouleur((Color)couleurOrigine.elementAt(k));
						else
						{
							noeud.add(s);
							couleur.add((Color)couleurOrigine.elementAt(k));
							s.setSaCouleur(Parametrages.getCoulSelection ());
							position ++;
						}
					}
					sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
					
					courant.removeAllElements();
					couleurOrigine.removeAllElements();
				}
				if (!Usine.continu ()) break;
				
				try { Thread.sleep(VITESSE+200); }
				catch (InterruptedException e) {}
				
				for(int i=0; i<taille; i++)
				{
					UnSommet s  = (UnSommet)noeud.elementAt(i);
					s.setSaCouleur((Color)couleur.elementAt(i));
					sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
				}
			}
			break;
			case Constantes.NUM_ALGO_ORDO_OL : {sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
				Ordonnancement ordo = (Ordonnancement) res.elementAt(indice);
				Vector pas_a_pas = ordo.getPas_a_Pas();
				int[][] etape = ordo.getEtape();
				int position = 0;
				int taille = pas_a_pas.size();
				Vector noeud = new Vector();
				UnSommet courant = null;
				Color couleurOrigine = null;
				Vector couleur = new Vector();
				UnArbreGraphique arbre = sonModuleExecution.getPanneauAffichage().getPanelArbre().getArbre();
				for(int i=0; i<taille && Usine.continu (); i++){
					if(courant != null) {
						if(courant.getSonId() != etape[position][0])
							courant.setSaCouleur(couleurOrigine);
						else
						{
							courant.setSaCouleur(Parametrages.getCoulSelection ());
							position++;
						}		
					}
					courant = arbre.trouveSommet(((Integer)pas_a_pas.elementAt(i)).intValue());
					if(!noeud.contains(courant))
					{
						noeud.add(courant);
						couleur.add(courant.getSaCouleur());
					}
					couleurOrigine = courant.getSaCouleur();
					courant.setSaCouleur(Color.yellow);
					sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
					try { Thread.sleep(Parametrages.getVitesse()); }
					catch (InterruptedException e) {}
				}
				if (!Usine.continu ()) break;

				courant.setSaCouleur(Parametrages.getCoulSelection ());
				sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
				try { Thread.sleep(Parametrages.getVitesse()); }
				catch (InterruptedException e) {}
				
				taille = noeud.size();
				for(int i=0; i<taille; i++)
				{
					courant = (UnSommet)noeud.elementAt(i);
					courant.setSaCouleur((Color)couleur.elementAt(i));
					sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
				}
			}
			break;
		};
		if((res.size() - 1) > indice)
			sonModuleExecution.getToolBar().activerNext(true);
		if(indice != 0)
			sonModuleExecution.getToolBar().activerPrev(true);
		sonModuleExecution.getPanneauAffichage().getPanelArbre().getSonArbre().maj_x_y();
		sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
	}

	public void arret () { Usine.arret (); }

	/* lancement du thread */
	public synchronized void run()
	{		
		sonModuleExecution.getPanneauAffichage().afficherInfos(Constantes.MSG_RAPPORT_LANCEMENT_ALGO);		
		sonModuleExecution.getPanneauAffichage().afficherInfos("   Thread lance....ok");	
		Vector res = new Vector();
		
		try {
			switch (sonAlgo) {
				case Constantes.NUM_ALGO_ORDO_T:
					res = sonUsine.genOrdoT (sonABRDonnee);
				break;
				case Constantes.NUM_ALGO_ORDO_A :
					res.add(sonUsine.genOrdoA(sonABRDonnee));
				break;
				case Constantes.NUM_ALGO_ORDO_OL:
					res = sonUsine.genOrdoOptLocal(sonABRDonnee);
				break;
				case Constantes.NUM_ALGO_ORDOT_OG:
					res = sonUsine.genOrdoOptGlob(sonABRDonnee);
				break;
			};
			affiche_debut (res);
			/* Si Pas a Pas, alors dessiner sur l'arbre le premier ordo */
			if (sonModuleExecution.getToolBar().isPasapas()) {
				indice = 0;
				affiche_PAP (res);
			}
			/* Dbloquer les boutons de la ToolBar */
			if(res.size() > 1)
				sonModuleExecution.getToolBar().activerNext(true);
			sonModuleExecution.getToolBar().activerPrev(false);
			/* Mettre a jour les boutons de la toolBar */
			sonModuleExecution.getToolBar().activerExecution();
		}
		catch(Exception ex) {}
	}
}
