package moduleexecution;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

import modulecreation.UnPanelArbre;
import structuresgraphique.UnSommet;
import structuresgraphique.UnArbreGraphique;

/**
 * Cette classe reprsente un des deux panels execution dans lequel
 * on ne fait qu'afficher des arbres et des options par le clic droit
 * Celle ci hrite de la class UnPanelArbre qui permet
 * juste de les afficher
 */
public class UnPanelExecutionArbre extends UnPanelArbre implements MouseMotionListener, MouseListener
{
	// Le menu contextuel
	private JPopupMenu sonMenuPopup = new JPopupMenu();
	private String sonIntitulesMenu;
	private JMenuItem sonItemsPopup = new JMenuItem();

    private UnArbreGraphique telArbre=null;

	// Le sommet trouv quand on clique dessus
	private UnSommet sonSommetTrouve = null;

    	// methode pour definir l'arbre a afficher:
    	public void setArbre(UnArbreGraphique uag)
    	{
    		//System.out.println ("nouvel-arbre");
    		//System.out.println (uag);
     		sonArbre=uag;
     		repaint();
    	}

	public UnArbreGraphique getArbre() {return sonArbre;}
	
	
	/**
	 * Constructeur
	 * @param telArbre l'arbre  afficher dans le panel
     	*/
	public UnPanelExecutionArbre()
	{
	    super(new UnArbreGraphique());
		
		addMouseMotionListener(this);
		addMouseListener(this);	
		setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
		setBackground(Color.white);
        setPreferredSize(new Dimension(1500,1100));
	}
	
/**
	 * On clique sur un bouton de la souris
	 * @param e l'vnement correspondant
	 */
    // evenement:

    public void evenement(MouseEvent e)
    {
     if(e.isPopupTrigger())
     {
      // on regarde alors si correspond a un sommet:
      UnSommet SommetClique=detecteSommet(e.getX(),e.getY());
      if(SommetClique!=null)
      {
       // remplissage du menu popup:
       //sesIntitulesMenu[0]="nombre de strahler: "+SommetClique.getNbStrahler();
       // sesIntitulesMenu[1]="numero du registre: "+SommetClique.getNumRegistre();
       // provisoirement:
       sonIntitulesMenu = "nombre de strahler: "+SommetClique.getStrahler();
       sonMenuPopup = new JPopupMenu();
       sonItemsPopup = new JMenuItem(sonIntitulesMenu);
       sonMenuPopup.add(sonItemsPopup);
       sonMenuPopup.addMouseListener(this);
       // affichage du menu:
       sonMenuPopup.show((Component)e.getSource(), (int)e.getX(), (int)e.getY());
      }
     }
    }

    public void mousePressed(MouseEvent e){evenement(e);}
    public void mouseReleased(MouseEvent e){evenement(e);}
   	public void mouseClicked(MouseEvent e){}
	public void mouseDragged(MouseEvent e){}
	public void mouseMoved(MouseEvent e){}
	public void mouseExited(MouseEvent e) {}				
	public void mouseEntered(MouseEvent e){}
	
	/**
	 * Trouve si un sommet est prsent  un point donn
	 * @param telX l'abscisse du point
	 * @param telY l'ordonne du point
	 * @return true si trouv, false sinon
	 */
	public UnSommet detecteSommet(double telX, double telY)
	{
		UnSommet leSommetTrouve = null; 
		sonSommetTrouve = null;	
	
		// On recherche d'abord dans l'arbre existant 	
	 	leSommetTrouve = sonArbre.trouveSommet(telX, telY);
	 	if(leSommetTrouve != null)
	 	{
			sonXTemp=telX;
			sonYTemp=telY;
			
			return leSommetTrouve;
		}
		return null;	 	
	}
}


