package moduleparametrage;
import javax.swing.text.*;
import javax.swing.JTextField;

/**
 * Class permettant le fonctionnement d'un IntTextField.
 */
class IntTextDocument extends PlainDocument
{
	public void insertString(int telOffs, String telleStr, AttributeSet telA) throws BadLocationException
	{
		if(telleStr==null)
			return;
			
		String laOldStr=getText(0, getLength());
		String laNewString=laOldStr.substring(0, telOffs)+telleStr+laOldStr.substring(telOffs);
		
		if(canBecomeValid(laNewString))
			super.insertString(telOffs, telleStr, telA);
	}
	
	public boolean canBecomeValid(String telleStr)
	{
		try
		{
			Integer.parseInt(telleStr);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}
}

/**
 * Classe permettant de crer un JTextField n'acceptant que des entiers.
 */
public class IntTextField extends JTextField
{
	public IntTextField(int cols)
	{
		super(cols);
	}
	
	public IntTextField()
	{
		super();
	}
	
	protected Document createDefaultModel()
	{
		return new IntTextDocument();
	}
}