package moduleparametrage;

import parametres.*;
import ihm.*;
import moduleparametrage.IntTextField;
import moduleparametrage.ParametrageConstante;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class PanneauCentre extends JPanel implements ActionListener, ItemListener, MouseListener
{
	
    private String sesTexteLabels [] =
    		{"Aretes","","Racine","","Feuilles","","Sommets selectionnes","",
    		 "Sommets suivis","","Autres sommets","","Courbe ordonancement",""};
    	
    private JLabel sonTabJLabel [] = new JLabel[sesTexteLabels.length];

    private JButton sonValider;
    private JLabel sonExplication1;
    private JCheckBox sonAntiAliasing;
    private IntTextField saLargeur;
    private JColorChooser saBoiteCouleur;
    
    //private Dimension saTailleLabelTexte = new Dimension(150,25);
    private Dimension saTailleLabelCouleur = new Dimension(25,25);

    //private boolean sonTestAntiAliasing = false;
    private static String sonChoixCouleur = "Choix couleur";
	private IHM sonIhm = null;
	
	private GridBagConstraints sesContraintes = new GridBagConstraints();
	
    public PanneauCentre(IHM telleIhm)//constructeur
    {
        setLayout(new GridLayout(1,2));
        saBoiteCouleur = new JColorChooser();
        
        sonIhm = telleIhm;

        // PANNNEAU GAUCHE
        JPanel panneauGauche = new JPanel();
        panneauGauche.setBorder(BorderFactory.createTitledBorder(ParametrageConstante.COLORATION));
        
        panneauGauche.setLayout(new GridBagLayout());

        //preparation des composants
        for(int i=0; i<sonTabJLabel.length; i++)
        {
        	sonTabJLabel[i] = new JLabel();
        	sonTabJLabel[i].setOpaque(true);
        	sonTabJLabel[i].setText(sesTexteLabels[i]);
        	
//        	if(i%2 == 0)
//        	{
//              	sonTabJLabel[i].setPreferredSize(saTailleLabelTexte);
//           }
        	if(i%2!=0)
        	{
        		sonTabJLabel[i].setPreferredSize(saTailleLabelCouleur);
        		sonTabJLabel[i].addMouseListener(this);
        	}
        }

        sesContraintes.gridheight=7;
        sesContraintes.gridwidth=2;
        // Ajout des labels 
        sesContraintes.insets=getInsets();
		for(int i=0; i<sonTabJLabel.length; i++)
        {
        	ParametrageConstante.add(i%2, i/2, 1, 1, sonTabJLabel[i++], sesContraintes, panneauGauche);
        	ParametrageConstante.add(i%2, i/2, 1, 1, sonTabJLabel[i], sesContraintes, panneauGauche);
    	}
        
        // Definition des parametres par defaut
        Parametrages.init ();
		sonTabJLabel[1].setBackground(sonIhm.getPanelBase().getColorAretes());
        sonTabJLabel[3].setBackground(sonIhm.getPanelBase().getColorRacine());
        sonTabJLabel[5].setBackground(sonIhm.getPanelBase().getColorFeuilles());
        sonTabJLabel[7].setBackground(Color.green);
        sonTabJLabel[9].setBackground(Color.yellow);
        sonTabJLabel[11].setBackground(sonIhm.getPanelBase().getColorAutresSommets());
        sonTabJLabel[13].setBackground(Color.pink);

        add(panneauGauche);

        //panneau Droit: Creation
        //definition du layout
        JPanel panneauDroit = new JPanel();
        panneauDroit.setBorder(BorderFactory.createTitledBorder(ParametrageConstante.CREATION));
        
        panneauDroit.setLayout(new GridBagLayout());
        sesContraintes.gridwidth=3;
        sesContraintes.gridheight=2;
        

        //preparation et ajout des composants ligne par ligne
        sonAntiAliasing = new JCheckBox(ParametrageConstante.ANTI_ALIASING);
        sonAntiAliasing.setSelected(sonIhm.getPanelBase().getAntiAliasState());
        //sonAntiAliasing.setPreferredSize(new Dimension(150,25));
        sonAntiAliasing.addItemListener(this);
        
        sesContraintes.anchor=GridBagConstraints.WEST;
        ParametrageConstante.add(0, 0, 3, 1, sonAntiAliasing, sesContraintes, panneauDroit);
        sesContraintes.anchor=GridBagConstraints.CENTER;
        
        sesContraintes.fill=GridBagConstraints.HORIZONTAL;
        ParametrageConstante.add(0, 1, 3, 1, new JSeparator(JSeparator.HORIZONTAL), sesContraintes, panneauDroit);
        sesContraintes.fill=GridBagConstraints.NONE;
        
        sonExplication1 = new JLabel(ParametrageConstante.LARGEUR);
        sonExplication1.setHorizontalAlignment(JLabel.RIGHT);
        //sonExplication1.setPreferredSize(new Dimension(250,25));
        //sonExplication1.setBackground(Color.blue);
        ParametrageConstante.add(0, 2, 1, 1, sonExplication1, sesContraintes, panneauDroit);
        
        saLargeur = new IntTextField(10);
        saLargeur.setText(String.valueOf(sonIhm.getPanelBase().getDiametreSommets()));
        //saLargeur.setPreferredSize(new Dimension(75,25));
        ParametrageConstante.add(1, 2, 1, 1, saLargeur, sesContraintes, panneauDroit);

        sonValider = new JButton(ParametrageConstante.VALIDER_CREATION);
        //sonValider.setPreferredSize(new Dimension(150,25));
        sonValider.addActionListener(this);
        sesContraintes.anchor=GridBagConstraints.EAST;
        ParametrageConstante.add(0, 3, 3, 1, sonValider, sesContraintes, panneauDroit);
        add(panneauDroit);
    }//fin constructeur

    //methode permettant de changer la couleur des parametres
    public void changeCouleur(int indiceButton,int indiceLabel)
    {
        Color couleur=sonTabJLabel[indiceLabel].getBackground();
        couleur = saBoiteCouleur.showDialog(this," Choix D'une Nouvelle Couleur ",couleur);
        
        if(couleur != null && couleur != sonTabJLabel[indiceLabel].getBackground())
        {
            sonTabJLabel[indiceLabel].setBackground(couleur);
            switch(indiceButton)
            {
            	case 0:	//Parametrages.setCoulAretes(couleur);
            			sonIhm.getPanelBase().majColorColorAretes(couleur);
            			break;
            			
            	case 1: Parametrages.setCoulRacine(couleur);
            			sonIhm.getPanelBase().majColorRacine(couleur);
            			break;
            	
            	case 2:	Parametrages.setCoulFeuilles(couleur);
                		sonIhm.getPanelBase().majColorFeuilles(couleur);
                		break;
                		
                case 3:	Parametrages.setCoulSelection(couleur);
                		break;
                		
                case 4: Parametrages.setCoulSuivi(couleur);
                		break;
                
                case 5:	Parametrages.setCoulSommets(couleur);
                		sonIhm.getPanelBase().majColorAutresSommets(couleur);
                		break;
                		
                case 6:	Parametrages.setCoulCourbe(couleur);
            }
            
        }
    }

    public JLabel getJLabel(int indice)
    {
        return (sonTabJLabel[indice]);
    }

    public void actionPerformed(ActionEvent a)
    {
           
        if(a.getSource() == sonValider)
        {

            String valeurDiametre = saLargeur.getText();
            try
            {
                double diametre = Double.parseDouble(valeurDiametre);
                Parametrages.setDiametreSommets(diametre);
                sonIhm.getPanelBase().majDiametreSommets(diametre);
            }
            catch(NumberFormatException e)
            {
                JOptionPane.showMessageDialog(this,ParametrageConstante.MESSAGE,"Erreur",JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    public void itemStateChanged(ItemEvent a)
    {
        if(a.getSource() == sonAntiAliasing)
        {
        	sonIhm.getPanelBase().setAntiAlias(sonAntiAliasing.isSelected());
        	sonIhm.getSonPanneauExecution().getPanneauAffichage().getPanelCourbe().setAntiAlias(sonAntiAliasing.isSelected());
        	sonIhm.getSaBarreMenu().setCheckBoxAntiAliasing(sonAntiAliasing.isSelected());
        }
    }
    
    public void setCheckBoxAntiAlias(boolean b)
    {
    	sonAntiAliasing.setSelected(b);
    }
    
    public void setSaLargeurTexte(String telTexte)
    {
    	saLargeur.setText(telTexte);	
    }
    
    public void mouseClicked(MouseEvent e)
    {
    	int cpt=-1;
    	for(int i=0; i<sonTabJLabel.length;i++)
    	{
    		if(i%2==0)
    			++cpt;
    		
    		if(e.getSource() == sonTabJLabel[i]) {
    			changeCouleur(cpt,i);
    			return;
    		}
    	}
    }

    public void mouseEntered(MouseEvent e)
    {
    	if(e.getSource() instanceof JLabel)
    	{
    		((JLabel)e.getSource()).setCursor(new Cursor(Cursor.HAND_CURSOR));
    	}	
    }
    
    public void mousePressed(MouseEvent e){}
    public void mouseReleased(MouseEvent e){}
    public void mouseExited(MouseEvent e){}
    
    
    
    public Insets getInsets()
    {
    	return new Insets(3, 5, 3, 5);
	}
}
