package moduleparametrage;

import parametres.*;
import ihm.*;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

public class PanneauSud extends JPanel implements ChangeListener
{
    private JSlider sonJSlider=null;
    private JLabel sonAffichage,saLegende;
    private int saVitesse = 0;
    private IHM sonIhm = null;

    public PanneauSud(IHM telleIHM)//constructeur
    {
    	sonIhm = telleIHM;

        setLayout(new BorderLayout());
        
        setBorder(BorderFactory.createTitledBorder(ParametrageConstante.VITESSE));

		// Le slider
        sonJSlider = new JSlider(SwingConstants.HORIZONTAL,500,5000,ParametrageConstante.VITESSE_DEFAULT);
        //sonJSlider.setPreferredSize(new Dimension(100, 25));
        sonJSlider.setPaintTicks(true);
        sonJSlider.setPaintLabels(true);
        sonJSlider.setMajorTickSpacing(500);
        sonJSlider.setMinorTickSpacing(100);
        sonJSlider.addChangeListener(this);
        //sesContraintes.fill = GridBagConstraints.HORIZONTAL;
        add(sonJSlider, BorderLayout.CENTER);
        //ParametrageConstante.add(0, 0, 1, 1, sonJSlider, sesContraintes, this);
        //sesContraintes.fill = GridBagConstraints.NONE;
        
		// Le label
        sonAffichage = new JLabel(ParametrageConstante.VITESSE_MSECONDES+" "+ParametrageConstante.VITESSE_DEFAULT);
        sonAffichage.setPreferredSize(new Dimension((int)150,(int)sonAffichage.getSize().getHeight()));
        //ParametrageConstante.add(1, 0, 1, 1, sonAffichage, sesContraintes, this);
        add(sonAffichage, BorderLayout.EAST);
        Parametrages.setVitesse(ParametrageConstante.VITESSE_DEFAULT);
    }

    public void setSonAffichage(String telTexte)
    {
        sonAffichage.setText(ParametrageConstante.VITESSE_MSECONDES+" "+telTexte);
    }

    public void setCurseur(int telleValeur)
    {
        sonJSlider.setValue(telleValeur);
    }

    public void stateChanged(ChangeEvent a)
    {
        String chaine = ""+sonJSlider.getValue();
        String chaine2;
        

        chaine2= ParametrageConstante.VITESSE_MSECONDES + " " + sonJSlider.getValue();

        sonAffichage.setText(chaine2);
        try
        {
            int valeur = Integer.parseInt(chaine);
            Parametrages.setVitesse(valeur);
        }
        catch(NumberFormatException e)
        {
            JOptionPane.showMessageDialog(sonIhm,ParametrageConstante.MESSAGE,"Erreur",JOptionPane.ERROR_MESSAGE);
        }
    }

}
