package structuresdonnees;


import java.util.Vector;

public class ABP
{
	/* Attributs */
	
	private Noeud [] arbre; /* stocke tous les noeuds */
	private int hauteur; /* hauteur de l'arbre */
	private Vector ordo; /* liste de tous les ordonnancements de l'abre */

	/* Constructeur */
	public ABP (int hauteur)
	{
		/* le nombre de noeud d'un arbre binaire parfait est 2^h - 1, mais
		comme on commence  l'indice 1 pour ne pas avoir de problmes avec
		la rgle 2i, 2i+1 on a besoin d'une case supplmentaire */
		arbre = new Noeud [(int) Math.pow (2, hauteur)];
		ordo = new Vector ();
		arbre[1] = new Noeud();//on rajoute la racine qui existe toujours
		this.hauteur = hauteur;
	}

	/* Mthodes utiles */
	
	/*recopie d'un tableau dans un autre*/
	private static Noeud[] recopie (Noeud []tab1, Noeud []tab2)
	{
		int i,j;
		for (i=0; i<tab1.length; i++)
		tab1[i] = tab2[i];
		return tab1;
	}

	/* pour initialiser le tableau de noeuds */
	public void setArbre(Noeud[] larbre)
	{
		arbre=larbre;
	}
	
	public void setHauteur()
	{
		int i,j;
		int temp=0;
		int newH=0;
		int niv = 1;
		int indice = niv+1; 
		while (indice <=arbre.length)
		{
			temp=0;
			for (i=indice-niv; i<indice; i+=2)
			{
					
				temp+=arbre[i]!=null?1:0;
					
			}
				if (temp ==0)
				newH++;
			
				niv*=2;
				indice+=niv;
		}
		hauteur=hauteur - newH;
		arbre = recopie(new Noeud[(int) Math.pow (2, hauteur)],arbre);
	}
	
	/*pour ajouter un noeud  un emplacement prcis de l'arbre*/
	public boolean setNoeud(int i)
	{
		if (i>= arbre.length)
		return false;
		if (i==1) return false;
		int pere = i/2;
		
		/*il faut que le noeud qu'on rajoute ait un pre*/
		if (arbre[pere]==null)
		return false;
		
		int fg = (i/2)*2;
		int fd = (i/2)*2 +1;
		
		arbre[fg] = new Noeud();
		arbre[fd] = new Noeud();
		return true;
	}
	
	/* ajoute un noeud  un emplacement  partir d'un dj existant. On 
     * ne fait pas de vrifications sur cette mthode car elle est appele
     * uniquement par la mthode de lecture qui ne fait pas n'importe quoi */
    public void setNoeud (int i, Noeud node)
    {
        if (i >= arbre.length) return;
        if (i < 1) return;
        arbre [i] = node;
    }
	
	/*Surcharge pour la gnration*/
		public void setNoeud(int i, int label)
	{
		if (i>= arbre.length)
		return;
		if (i==1) return;
		int pere = i/2;
		
		/*il faut que le noeud qu'on rajoute ait un pre*/
		if (arbre[pere]==null)
		return ;
		
		int fg = (i/2)*2;
		int fd = (i/2)*2 +1;
		
		arbre[fg] = new Noeud(label);
		arbre[fd] = new Noeud(label);
	}
		
	
	/* Cette mthode renvoit une reprsentation d'un tage de l'arbre */
	public String getNiveau (int niv)
	{
		int debut, fin;
		int i;
		String niveau;
		debut = (int) Math.pow (2, niv - 1);
		fin = (int) Math.pow (2, niv);
		niveau = "";
		for (i = debut; i < fin; i++)
			niveau += (arbre [i] == null)? 0 : 1;
		return niveau;
	}
	
	public int getLength()
	{
		return arbre.length;
	}

	/* renvoie les ordonnancements de l'arbre */
	public Vector getOrdo () { return ordo; }
	
	/* methode ajoutant un ordo */
	public void addOrdo(Ordonnancement o){ ordo.add(o); }
	
	
	/*Simple parcours pour attribuer  chaque noeud le nombre de Strahler lui correspondant*/
	public int calculStrahler(int i)
	{
		int fg,fd;
		
		if (i>= arbre.length)
		return 0;
		
		if (estFeuille(i))
		{
			arbre[i].setStrahler(1);
			return 1;
		}
		
		fg=calculStrahler(2*i);
		fd=calculStrahler(2*i+1);
		
		if (fd == fg)
		{
			arbre[i].setStrahler(fg +1);
			return fg +1;
		}
		
		else if (fd > fg) 
		{
			arbre[i].setStrahler(fd);
			return fd;
		}
		else 
		{
			arbre[i].setStrahler(fg);
			return fg;
		}	
		
	}
	
	
	/*regarde si 2*i est dans le tableau et si il y a un noeud*/
	public boolean estFeuille (int i)
	{
		if (2*i >= arbre.length)
		return true;
		
		if (arbre[2*i] == null)
		return true;
		
		return false;
	}
	
	/*fonction renvoyant le noeud + son nombre de strahler plus ses 2 fils*/ 
	private String getNoeud(int i)
	{
		if (i>= arbre.length)
		{
			System.out.println("erreur d'indice");
			return null;
		}
		
		if (estFeuille(i))
		return "(feuille "+i+"->"+arbre[i].toString();
		
		else return "( noeud "+i+"->"+arbre[i].toString() +"("+getNoeud(2*i)+")"+"("+getNoeud(2*i+1)+")";
		
	}
	
	/*Renvoie une reprsentation binaire de l'arbre*/
	public int[] getArbre()
	{
		int []t = new int[arbre.length];
		int i;
		for (i=0; i<arbre.length; i++)
		t[i] = arbre[i]==null?0:1;
		return t;
	}
	
	/*renvoie un noeud  l'indice i*/
	public Noeud getObjNoeud(int i)
	{
    	return (i < arbre.length) ? arbre[i] : null;
	}
	
	/* Methode reournant une liste de toutes les feuille de l arbres */
	public int getFeuille(Vector feuille)
	{
		int k = 0;
		for(int i=0; i<arbre.length; i++)
		{
			if(arbre[i]!= null)
			{
				k++;
				arbre[i].setMarque(false);
				if(estFeuille(i))
					feuille.add(new Integer(i));
			}
		}
		return k;
	}
	
	/*parcours de l'arbre (debugging)*/
	public String toString()
	{
		int i;
		String tmp = "";
		for (i = 1; i < arbre.length ; i++)
			if (arbre [i] != null)
				tmp += "1 ";
			else
				tmp += "0 ";
		return tmp;
	}
}

