package structuresdonnees;


import java.io.*;
import java.util.Hashtable;
import java.util.Vector;
import java.util.StringTokenizer;
import java.awt.Color;


public class Flux
{
	/* Attributs */
	
	private File fichier; /* fichier  lire ou dans lequel crire */
	private static final String [] entete = {"LEDA.GRAPH", "string", "string"};
	/* entte d'un fichier LEDA */

	public Flux (String nom)
	{
		fichier = new File (nom);
	}

	/* permet d'afficher un petit message en cas d'erreur dans le fichier */
	private void mauvais_Format ()
	{
		Usine.affiche_erreur ("Fichier non LEDA ou erreur de format");
	}
	
	/* cherche  lire un nombre  partir de la position donne */
	private int lire_nombre (BufferedReader buffer, String ligne)
	{
		int nbr = 0;
		ligne = ligne.trim ();
		/* on se contente de lire jusqu'au premier nombre */
		try {
			while ((nbr <= 0) && (ligne != null)) {
				ligne = ligne.trim ();
				try { 
					nbr = Integer.parseInt (ligne);
					return nbr;
				}
				catch (NumberFormatException e) {}
				if ((ligne.length () != 0) && (ligne.charAt (0) != '#'))
						return 0;
				ligne = buffer.readLine ();
			}
		}
		catch (IOException e) {}
		return nbr;
	}

	/* cette fonction prend une chaine infos et renvoie le vector d'infos
	 * correspondant. La fonction retourne null si il n'y a pas d'infos
	 *  mettre. Si il n'y a pas que des couples variable/info elle renvoie
	 * null aussi pour viter de propager des erreurs de cohrences ou de 
	 * dcaler des infos */
	private Vector extrait_Infos (String infos)
	{
		Vector retour;
		StringTokenizer token;/* dcoupe la chaine au niveau des virgules */
		int nbr_infos; /* compte le nombre de couples variable/info */
		int j; /* va servir d'indice dans le vector  renvoyer */
		/* si y'a pas d'infos on renvoi un vector vide */
		if (infos == null) return null;
		infos = infos.trim ();
		if (infos.length () == 0) return null;
		/* on va stocker les couples variable/infos dans le vector */
		retour = new Vector ();
		token = new StringTokenizer (infos, ",");
		/* si on a pas un nombre de tokens pair, on zap pour viter
		 * des erreurs de cohrences dans la suite */
		if (((nbr_infos = token.countTokens ()) % 2) != 0) {
			Usine.affiche_erreur ("Les infos sont corrompues ! Verifiez qu'il y'a des couples variables,infos");
			return null;
		}
		/* on remplit le petit vector */
		j = 0;
		while (nbr_infos > 0) {
			retour.addElement (new String [2]);
			for (int i = 0; i < 2; i++)
				((String []) retour.elementAt (j)) [i] = token.nextToken ();
			nbr_infos -= 2;
			j++;
		}
		return retour;
	}
		
	/* cette mthode tente d'extraire les infos utiles d'une ligne sense
	 * contenir des infos sur un noeud, elle renvoie null sinon */
	private Noeud decortique_noeud (String ligne)
	{
		int couleur = -1; /* couleur du noeud */
		String coul;
		Noeud retour;
		int taille; /* taille de la chaine */
		int pos_vir; /* position de la virgule sparant la couleur du reste */
		int nbr_infos; /* va permettre de compter le nombre d'infos contenues
						  dans un noeud : il faut que ce nombre soit pair :
						  une variable suivi d'une valeur */
		ligne = ligne.trim ();
		/* pourquoi 6 ? car il faut que la ligne contienne au moins |{#,}|
		 * avec # tant un chiffre reprsentant la couleur */
		if (ligne.length () < 6)
			return null;
		if (!ligne.endsWith ("}|") || !ligne.startsWith("|{"))
			return null;
		taille = ligne.length ();
		/* on enlve les |{ et }| de la chaine */
		ligne = ligne.substring (2, taille - 2);
		taille = ligne.length ();
		/* on localise la sparation (c'est  dire la premire virgule
		 * rencontre */
		pos_vir = ligne.indexOf (',');
		if (pos_vir < 0) return null;
		/* on extrait la couleur */
		coul = ligne.substring (0, pos_vir);
		/* au cas o un petit malin met des espaces avant et aprs le nombre */
		coul = coul.trim ();
		try { couleur = Integer.parseInt (coul); }
		catch (NumberFormatException e) {}
		if (couleur == -1) return null;
		retour = new Noeud ();
		/* on stocke ce qu'il faut dans le noeud */
		retour.setCouleur (new Color (couleur));
		retour.setInfosNoeud (extrait_Infos (ligne.substring (pos_vir + 1,
						taille)));
		/* et zou on le renvoi */
		return retour;
	}
		
	/* cette mthode est charge de lire un paquet de noeuds */
	private Vector lire_noeuds (BufferedReader buffer, String ligne)
	{
		int nbr;
		Vector retour;/* vector de noeuds */
		Noeud tmp;
		nbr = lire_nombre (buffer, ligne);
		/* on vrifie que le nombre de noeuds est bien impair et
		 * strictement positif sinon on renvoie null */
		if ((nbr <= 0) || (((nbr + 1) % 2) != 0)) return null;
		/* si on arrive l, c'est qu'on a bien lu un nombre valide ...
		 * reste  savoir si on a autant de noeuds que promis ... */
		retour = new Vector ();
		/*  partir de l on va lire les infos sur les noeuds. 3 cas de 
		 * figures se prsentent :
		 *   - le nombre de noeuds est correct, et l pas de pb.
		 *   - le nombre noeuds est plus grand que prvu et l, il y'a une 
		 *   	erreur
		 *   - le nombre est plus petit que le nombre rel de noeuds et dans
		 *   	ce cas les noeuds "aprs" seront ignors. */
		try {
			while ((nbr > 0) && ((ligne = buffer.readLine ()) != null)) {
				tmp = decortique_noeud (ligne);
				/* si la ligne n'est pas un noeud on se barre en courant : y'a 
				 * une erreur dans le fichier */
				if (tmp == null) return null;
				retour.addElement (tmp);
				/* on a un noeud de moins  lire */
				nbr --;
			}
			/* si il restait des noeuds  lire mais qu'on est arriv  la fin
			 * du fichier, c'est pas bon */
			if (nbr != 0) return null;
		}
		catch (IOException e) { return null; }
		return retour;
	}

	/* la mthode est ici pas trs jolie puisqu'on renvoi un tableau de String
	 * qui va contenir les infos de l'arte : dpart, arrive, commentaires.
	 * La mthode nous assure que, malgr les apparences, les deux premires
	 * cases tu tableau contiennent des entiers */
	private String [] decortique_arete (String ligne, int taille)
	{
		String [] retour;
		ligne = ligne.trim ();
		StringTokenizer token;
		/* dans ce tableau on aura dans l'ordre : un entier (dpart de la
		 * racine), un entier (arrive), une String (commentaire de l'arte) */
		String ch_tmp; /* va permettre de stocker temporairement la ligne
						  de commentaire de l'arte */
		int nb_tmp; /* stocke l'indice du noeud */
		retour = new String [3];
		token = new StringTokenizer (ligne, " ");
		/* si on a moins de 4 champs, c'est pas bon :
		 * car on doit avoir au moins # # # # |{}|
		 * avec # un chiffre */
		if (token.countTokens () < 4) return null;
		/* on commence par stocker betement les indices des noeuds */
		for (int i = 0; i < 2; i++) {
			try { nb_tmp = Integer.parseInt (token.nextToken ().trim ()); }
			catch (NumberFormatException e) { return null; }
			/* si on tombe sur plus petit que 1 ou plus grand que le nombre
			 * de noeuds, c'est pas bon */
			if ((nb_tmp < 1) || (nb_tmp > taille)) return null;
			retour [i] = "" + (nb_tmp - 1); /* on met -1 car LEDA commence 
											 compter  partir de 1 et nous 0 */
		}
		/* on vrifie que l'arte ne boucle pas sur elle mme ... */
		if (retour [1] == retour [2]) return null;
		/* arriv ici on doit stocker le commentaire de l'arte.
		 * On doit d'abord zaper le caractre qui ne sert  rien, le 3me
		 * nombre de la ligne */
		ch_tmp = token.nextToken ();
		ch_tmp = "";
		while (token.hasMoreTokens ()) ch_tmp += token.nextToken () + " ";
		/* les commentaires doivent apparaitre dans |{ }| */
		ch_tmp = ch_tmp.trim ();
		if (!ch_tmp.endsWith ("}|") || !ch_tmp.startsWith ("|{"))
			return null;
		nb_tmp = ch_tmp.length ();
		/* on extrait juste le commentaire en lui mme et on le stocke */
		ch_tmp = ch_tmp.substring (2, nb_tmp - 2);
		retour [2] = ch_tmp;
		/* maintenant les infos sur l'arte sont formates et prtes  tre
		 * envoyes  la mthode appelante qui n'aura plus qu' convertir
		 * les deux premires cases en entier */
		return retour;
	}

	/* cette fonction dtermine si un arbre est valide. Elle vrifie qu'il n'y
	 * a une tte et une seule. Elle vrifie que chaque fils  soit 0 soit 2
	 * noeuds. Enfin, elle vrifie que le futur arbre est bien un arbre */
	private boolean valide (int fils [][], boolean [] tete)
	{
		int nbr, ind; /* nombre de ttes et indice de la dernire tte */
		boolean [] marque; /* va dterminer si chaque noeud n'a qu'un seul pre */
		int taille = tete.length;
		nbr = 0;
		ind = 0;
		marque = new boolean [taille];
		for (int i = 0; i < taille; i++) marque [i] = false;
		for (int i = 0; i < taille; i++) {
			if (tete [i]) {
				nbr++;
				/* on se rappel de l'emplacement de la tte */
				ind = i;
			}
			/* si un fils a un fils c'est pas bon. */
			if (fils [i][0] == 1) return false;
			/* si y'a des fils on regarde si ils ne sont pas dj les fils 
			 * d'un autre noeud */
			if (fils [i][0] == 2) {
				/* si un des deux fils est marqu, c'est pas bon, sinon
				 * on les marque. On fait les tests et les marques les unes
				 * aprs les autres pour tre sur qu'un mme noeud n'ai pas
				 * deux fois le mme fils */
				if (marque [fils [i][1]]) return false;
				marque [fils [i][1]] = true;
				if (marque [fils [i][2]]) return false;
				marque [fils [i][2]] = true;
			}
		}
		/* si il y'a un nombre de ttes diffrent de 1 c'est pas bon */
		if (nbr != 1) return false;
		/* si la tte est le fils de quelqu'un c'est pas bon ... */
		if (marque [ind]) return false;
		/* si tout s'est bien pass, on est  peu prs sur qu'il s'agisse d'un
		 * ABP valide. Mais errare humanum est ! */
		return true;
	}

	/* compte juste le nombre de noeud accessibles  partir d'un certain
	 * noeud */
	private int est_connexe (int [][] fils, int indice)
	{
		int nbr_noeud = 1;
		/* si on est dans une feuille, on a un noeud de plus */
		if (fils [indice][0] == 0) return nbr_noeud;
		nbr_noeud += est_connexe (fils, fils [indice][1]);
		nbr_noeud += est_connexe (fils, fils [indice][2]);
		return nbr_noeud;
	}

	/* dtermine la hauteur d'un ABP */
	private int rend_hauteur (int [][] fils, int indice)
	{
		int h = 1;
		int tmp1, tmp2;
		/* dans la suite (notamment dans la structure ABP, une racine
		 * est  la hauteur 1 */
		if (fils [indice][0] == 0) return h;
		tmp1 = 0;
		tmp2 = 0;
		tmp1 += rend_hauteur (fils, fils [indice][1]);
		tmp2 += rend_hauteur (fils, fils [indice][2]);
		/* on prend la plus grande des deux hauteurs */
		h += (tmp1 > tmp2 ? tmp1 : tmp2);
		return h;
	}
		
	/* petite mthode qui va permettre de savoir si un ABP est connexe et
	 * en mme temps dtermine sa hauteur cette mthode est juste l'appel
	 * rcursif  la vraie mthode */
	private int connexe (int [][] fils, boolean [] tete)
	{
		int ind = -1; /* indice de la tte */
		int i = 0;
		while (ind == -1)
			if (tete [i++]) ind = i - 1;
		/* on regarde combien on a pu visiter de noeuds en partant de la 
		 * tte ... si il est diffrent du nombre total de noeud, l'ABP
		 * n'est pas connexe */
		if (est_connexe (fils, ind) != tete.length) return -1;
		/* on dtermine la hauteur de l'ABP et on la renvoie */
		return rend_hauteur (fils, ind);
	}
	
	/* remplit l'arbre avec les noeuds */
	private ABP remplir (ABP arbre, int [][] fils,
			Vector noeuds, int i_fils, int i_abp)
	{
		int fg, fd;
		arbre.setNoeud (i_abp, (Noeud) noeuds.elementAt (i_fils));
		if (fils [i_fils][0] == 0) return arbre;
		fg = i_abp * 2;
		fd = i_abp * 2 + 1;
		arbre = remplir (arbre, fils, noeuds, fils [i_fils][1], fg);
		arbre = remplir (arbre, fils, noeuds, fils [i_fils][2], fd);
		return arbre;
	}
	
	/* va permettre d'appeler la mthode remplissant l'ABP */
	private ABP remplir_ABP (ABP arbre, int [][] fils,
			Vector noeuds, boolean [] tete)
	{
		int ind = -1; /* on cherche vite la tte */
		int i = 0;
		while (ind == -1)
			if (tete [i++]) ind = i - 1;
		/* et on remplit l'ABP pour de bon  partir de la tte (indince = 0),
		 * premire position (1) */
		return remplir (arbre, fils, noeuds, ind, 1);
	}
		
	/* mthode qui lit le bloc artes */
	private ABP lire_aretes (Vector noeuds, BufferedReader buffer)
	{
		ABP retour;
		boolean [] tete; /* va permettre de savoir qui est la tte de l'arbre
							et de dtecter les erreurs dans le cas d'un arbre
							corrompu */
		int fils [][]; /* on stockera la dedans les fils des noeuds la
						  premire case servira  savoir combien on a de fils */
		String ligne;
		int nbr; /* nombre affichs en tte de la section artes */
		int taille; /* nombre de noeuds */
		String [] tmp;
		int dep, ariv; /* stocke temporairement les indices des noeuds
						  de la racine */
		int hauteur = 1; /* va recevoir la hauteur de l'ABP. On met  1
							c'est  dire quivalent  une racine seule */
		nbr = lire_nombre (buffer, "");
		/* si a pas nbr_arete = nbr_noeud - 1 c'est pas bon */
		taille = noeuds.size ();
		if ((nbr < 0) || (nbr != taille - 1)) return null;
		fils = new int [taille][3];
		tete = new boolean [taille];
		/* au dbut, tous les noeuds sont des ttes potentielles et ils ont
		 * 0 fils */
		for (int i = 0; i < taille; i++) {
			tete [i] = true;
			fils [i][0] = 0;
		}
		/* maintenant on peut tenter de lire la section des artes */
		try {
			while ((nbr > 0) && ((ligne = buffer.readLine ()) != null)) {
				tmp = decortique_arete (ligne, taille);
				/* si la ligne n'est pas une arte on se barre en courant : y'a 
				 * une erreur dans le fichier */
				if (tmp == null) return null;
				/* on va maintenant mettre  jours les diffrents lments que
				 * l'on a avec les infos de l'arte */
				dep = Integer.parseInt (tmp [0]);
				ariv = Integer.parseInt (tmp [1]);
				/* l'arrive d'une racine ne peut pas tre tte */
				tete [ariv] = false;
				/* si on plus que deux fils c'est pas bon */
				if (++fils [dep][0] >= 3) return null;
				/* on stocke l'indice du fils */
				fils [dep][fils [dep][0]] = ariv;
				((Noeud) noeuds.elementAt(ariv)).setInfosArete (extrait_Infos (tmp [2]));
				/* on a une arte de moins  lire */
				nbr --;
			}
			/* si il restait des artes  lire mais qu'on est arriv  la fin
			 * du fichier, c'est pas bon */
			if (nbr != 0) return null;
			/* arriv ici, on toutes les cartes en mains pour contruire l'ABP,
			 *  condition qu'il soit valide, bien sur :) A ce stade il 
			 * pourrait ne pas tre valide pour 3 raisons : nombre de fils
			 * de chaque noeuds != 0 ou 2, nombre de tte != 1,
			 * l'ABP boucle sur lui mme */

			/* on dtermine la validit de l'arbre */
			if (!valide (fils, tete)) return null;
			/* arriv ici le seul problme qui peut rester est que l'arbre
			 * soit valide mais non connexe : on va donc vrifier cel
			 * et en profiter pour rcuprer la hauteur du futur ABP */
			if ((hauteur = connexe (fils, tete)) < 0) return null;
			
		}
		catch (IOException e) { return null; }
		retour = new ABP (hauteur);
		return remplir_ABP (retour, fils, noeuds, tete);
	}
		
	/* c'est la fonction de lecture  proprement parl elle renvoie un ABP
	 * ou null si il y'a eu le moindre problme */
	public ABP lire ()
	{
		ABP ret;
		FileReader lecteur;
		BufferedReader buffer;
		String ligne;
		Vector noeuds; /* contient la liste des noeuds lus */
		int i;
		boolean ok;
		int tmp; /* on a toujours besoin d'un petit entier temporaire... :) */
		try {
			lecteur = new FileReader (fichier);
			buffer = new BufferedReader (lecteur);
			ok = false;
			i = 0;
			/* on lit l'entete du fichier */
			while (((ligne = buffer.readLine ()) != null) && (!ok)) {
				if ((ligne.trim ()).equals ((String) entete [i])) i++;
				if (i == 3)	ok = true;
			}
			/* on dtermine si il est correct :
			 * Pour avoir un entte "correct" un fichier leda doit tre
			 * formul ainsi : 
			 * LEDA.GRAPH
			 * string
			 * string
			 * Peut importe si il y'a des lignes vides entre */
			if (!ok) {
				mauvais_Format ();
				buffer.close ();
				return null;
			}
			/* puis on lit les infos  proprement parler ...
			 * on commence par les noeuds bien entendu */
			noeuds = lire_noeuds (buffer, ligne);
			if (noeuds == null) {
				mauvais_Format ();
				buffer.close ();
				return null;
			}
			/* maintenant, les artes ... */
			ret = lire_aretes (noeuds, buffer);
			buffer.close ();
			if (ret == null) {
				mauvais_Format ();
				return null;
			}
		}
		catch (IOException e) {
			Usine.affiche_erreur ("Erreur de lecture");
			return null;
		}
		return ret;
	}

	/* permet d'ajouter une ligne  un fichier */
	private void mettre (BufferedWriter buffer, String chaine)
	{
		try {
			buffer.write (chaine, 0, chaine.length ());
			buffer.newLine ();
		}
		catch (IOException e) {
			Usine.affiche_erreur ("Erreur d'ecriture");
		}
	}

	/* cette mthode permet de renvoyer les infos d'un vector sous forme
	 * d'une chaine de caractre toute prte  tre crite dans le fichier */
	private String concat_Infos (Vector infos)
	{
		String retour;
		int taille;
		String [] tmp;
		if (infos == null) return "";
		if ((taille = infos.size ()) == 0) return "";
		retour = "";
		for (int i = 0; i < taille; i++) {
			if ((tmp = (String []) infos.elementAt (i)) == null)
				retour = retour + ".,.,";
			else {
				for (int j = 0; j < 2; j++) {
					/* si on a une valeur  mettre, mme "", on la met */
					if ((tmp [j] != null) && (tmp [j].length () > 0)) 
						retour = retour + tmp [j];
					else retour = retour + ".";
					retour += ",";
				}
			}
		}
		/* on enlve la virgule en trop qui gene */
		taille = retour.length ();
		if (retour.charAt(taille - 1) == ',')
			retour = retour.substring (0, taille - 1);
		return retour;
	}
		
		
	/* cette mthode permet d'crire dans un fichier elle renvoie vrai
	 * si a c'est bien pass et faux sinon (logique).
	 * La mthode suppose que l'ABP pass en paramtre est correct, elle
	 * ne fait pas ou peu de vrifications dessus. */
	public boolean ecrire (ABP arbre)
	{
		FileWriter ecrivain;
		BufferedWriter buffer;
		String [] aretes; /* va contenir les reprsentations des artes */
		int nbr_noeud; /* nombre de noeuds  crire */
		int indice; /* va permettre de numroter les noeuds en forme LEDA */
		int ind; /* permet de maintenir un indice dans le String [] aretes */
		int taille; /* taille de l'arbre */
		int nb_tmp; /* pratique pour se souvenir des indices des fils */
		Noeud tmp, tmp2;
		String infos;
		int [] hash; /* on va stocker les correspondances entre les indices
						du tableau de noeuds et les indices LEDA */
		/* on essaye tout de mme de ne pas crire un ABP vide :) */
		if (arbre == null) return false;
		try {
			ecrivain = new FileWriter (fichier);
			buffer = new BufferedWriter (ecrivain);
			/* on crit l'entte du fichier */
			for (int i = 0; i < 3; i++) { mettre (buffer, entete [i]); }
			/* on va compter le nombre de noeuds  crire dans le fichier */
			nbr_noeud = 0;
			taille = arbre.getLength ();
			hash = new int [taille];
			for (int i = 1; i < taille; i++)
				if (arbre.getObjNoeud (i) != null)
					hash [i] = ++nbr_noeud;
			/* on crit le nombre de noeuds */
			mettre (buffer, "" + nbr_noeud);
			aretes = new String [--nbr_noeud];
			indice = 0;
			ind = 0;
			for (int i = 1; i < taille; i++) {
				if ((tmp = arbre.getObjNoeud (i)) != null) {
					indice++;
					/* si le noeud n'est pas une feuille, on stocke
					 * ses artes */
					if (!arbre.estFeuille (i)) {
						for (int j = 0; j < 2; j++) {
							nb_tmp = i * 2 + j;
							tmp2 = arbre.getObjNoeud (nb_tmp);
							infos = concat_Infos (tmp2.getInfosArete ());
							if (infos == null) infos = "";
							aretes [ind] = "" + hash [i] + " " +
							hash [nb_tmp] + " 0 |{" + infos
							+ "}|";
							ind++;
						}
					}
					infos = concat_Infos (tmp.getInfosNoeud ());
					if (infos == null) infos = "";
					/* vite les problmes si le noeud n'a pas de couleurs */
					if (tmp.getCouleur () != null)
						mettre (buffer, "|{" + tmp.getCouleur ().getRGB () 
						+ "," +	infos + "}|");
					else
						mettre (buffer, "|{0," + infos + "}|");
				}
			}
			mettre (buffer, "" + nbr_noeud);
			for (int i = 0; i < nbr_noeud; i++)
				mettre (buffer, aretes [i]);
			buffer.flush ();
			buffer.close ();
		}
		catch (IOException e) {
			Usine.affiche_erreur ("Erreur d'ecriture");
			return false;
		}
		return true;
	}
}
