package structuresdonnees;


import java.util.Vector;
class gen
{
    /*parcours d'un arbre pour dire s'il est valide*/
    private boolean estValide(int []tab)
    {
	int i;
	int nivmin = tab.length/2;
	/*vrification que les fils ne soient pas orphelins*/
	for (i=1; i<tab.length; i++)
	    if (tab[i] ==1 && tab[(i-1)/2] ==0) return false;
	/*vrification que la hauteur est bien respecte*/
	for (i=nivmin; i<tab.length; i++)
	    if (tab[i] ==1) return true;
		
		
		
	return false;
    }
	
    /*Vrification des symtries d'un tableau d'entiers avec les prcdents dans le vecteur*/
    /*on parcours les tableaux dans les deux sens  chaque niveau et on repre si il y a des symtries*/
    private boolean estSym (Vector v, int []tab, int t)
    {
	if (v.size() ==0) return false;
	int niv = 1;
	int indice = niv+t; 
	int i,j,k;
	boolean estSym=true;
	int []tab2 = new int[tab.length];
	for (k=0; k< v.size(); k++)
	    {	
		niv = 1;
		indice = niv+t; 
		estSym = true;
		if (t==0)//reprsentation binaire d'un entier
		    tab2=(int[])((int[])v.elementAt(k)).clone();
		else
		    tab2=(int[])((ABP)v.elementAt(k)).getArbre().clone();//reprsentation de l'arbre
		while (indice <=tab.length)
		    {
			j=indice-1;
			for (i=indice-niv; i<indice; i++)
			    {
					if (tab[i] != tab2[j]) {
				    estSym = false;
				    break;}
				j--;
					
			    }
			
			niv*=2;
			indice+=niv;
		    }
			
		if (estSym ==true) return true;
	    }
	return false;
    }
	
    //compteur qui recense le nombre d'arbres crs
    static int nb = 1;
    /*construit l'abp  partir du tableau, 1 signifie que le noeud i+1  deux fils*/
    public ABP consABP (int []tab, int hauteur)
    {
		
	int i;
	ABP result = new ABP(hauteur);
	for (i=0; i<tab.length; i++)
	    if (tab [i] != 0)
		result.setNoeud((i+1)*2);
	nb++;
	result.calculStrahler(1);
	return result;
    }
	
	
	
    /*Construit l'arbre d'apres un tab d'entiers reprsentant un parenthsage*/
    /*1 signifie que l'on ouvre une parenthse et 0 qu'on la referme 		 */	
    /*(on peut aussi voir cela comme un parcours prfixe)         			 */
    public ABP consABPN(int[]tab, int hauteur)
    {
	int i, j;

	ABP result = new ABP(hauteur);
	setN(tab, 2,result, 2);
	result.calculStrahler(1);
	return result;
			
		
    }
    
    /*Mthode rcursive qui cre l'arbre grace  un parcours prfixe*/
    private void setN(int []tab, int i, ABP arbre, int j) 
    {
    	
    	if (i>=tab.length) return;
    	if (tab[i-1] != 0)
       		while (!arbre.setNoeud(j))j/=2;

    	
    	if (tab[i]==1)
    		setN(tab, i+1, arbre, j*2);
    	else {
    		if ((j+1)%2 == 0)
    			setN(tab, i+1, arbre, j/2+1);
    		else setN(tab, i+1, arbre, j+1);
    		}
    }
	
	
    /*			Gnration selon l'ordre lexicographique 							*/
    /*(gnre tous les parenthsages possible pour un nombre interne de noeud donn)*/
    /*			(gnration combinatoire d'apres Joe Sawada)						*/
    private boolean genTab(Vector v,int []tab, int nbNoeud) 
    {

	int k,q,p,j;
	int hauteur = nbNoeud+1;
	ABP a;
	
	/*tant que tous les noeuds (ie 1) ne sont pas  gauche on continue*/
	k= 2*nbNoeud;//soit la longueur du tableau
	while (tab[k] == 0) k--;
	q= 2*nbNoeud -k;
	while (tab[k] == 1) k--;
	if (k==0) return false;//Sinon on stoppe 
	
	else { 
	    p= 2*nbNoeud -k -q;
	    tab[k]=1;
	    for(j=k+1; j<=k+q-p+2; j++) tab[j]=0;
	    j=2*nbNoeud - 2*p + 3;
	    while (j<=2*nbNoeud - 1) { 
		tab[j]= 1; 
		tab[j+1]= 0; 
		j= j+2;
	    }
	    a = consABPN((int[])tab.clone(), hauteur);
	    if (!estSym(v, a.getArbre(),1))//si la combinaison trouv n'a pas de symtrique on la prend
	 	{ 
	 		v.addElement(a);	
	 	}
		
	}	
	return true;
    }
	
    /*Gnration de tous les arbres selon le nombre de noeuds internes*/
    public Vector genNoeud(int nbNoeud)
    {
	nb=0;
	Vector v = new Vector();
	if (nbNoeud==0) {
		v.addElement (new ABP(1));
		return v;
	}
	int hauteur = nbNoeud +1;
	int longueur = 2*nbNoeud;
	int []tab = new int[longueur+1];
	int i,j;
	tab[0] = 0;
	//on construit le premier tableau (tous les noeuds sont  droite)
	for (i=1; i<=2*nbNoeud; i++)  tab[i] = i%2;
	v.addElement(consABPN((int[])tab.clone(), hauteur));
	while (genTab(v,tab, nbNoeud));
	return v;
	

    }
	
    /*gnration de tous les tableaux pour une hauteur donne*/
    public Vector genHauteur(int hauteur)
    {
	nb=0;
	int[] tableau=new int[1];
	int i;
	Vector v = new Vector();
	int[]tab = new int[(int)Math.pow(2, hauteur)]; // tab va contenir un arbre au complet
	if (hauteur-1==0) { // si la hauteur est gal  0 il n'y a qu'un seul seul sommet
	    v.addElement(new ABP(1)); // on peut donc directement l'ajouter
	    return v;
	}
	else if(hauteur-1==1) {
	    tab[0]=1;
	    v2.addElement((int[])tab.clone()); // si la hauteur est gale  1, il y'a trois sommets ce qui correspond juste  un un on l'ajoute donc directement
	}
	else {
	    tab[0]=1; // ceci correspond au tableau final qui contient dja le 1 qui est le pre de tout le tableau
	    tableau[0]=1; // ceci correspond au tableau pour la hauteur en cours
	    recur(tableau,hauteur-1,tab ,1); // on appelle donc la fonction qui va gnrer tous les arbres
	}
	/*on incrmente  chaque fois une entier de 2 et on prend sa reprsentation binaire*/
	for (i=0; i<v2.size(); i++) // une fois cette fonction appelle, on parcours le vecteur des arbres sous forme de tableau qu'on transforme en ABP et qu'on renvoie
	    {
		v.addElement(consABP((int[])v2.elementAt(i),hauteur));
			
		
	    }
				
	return v;
    }
	
	
    // cette fonction permet d'incrmenter un nombre binaire contenu dans le tableau
    private int incrementer(int[] tableau) 
    {
	int a=1; // contient la retenue pour incrmenter
	// on part des bits  droite
	for(int i=tableau.length-1;a==1 && i>=0;i--) 
	    {
	    	if (tableau[i]==1) // si le bit est  1, on le passe  0 et on garde la retenue  1
		    {
			tableau[i]=0;
		    } 
		else if (tableau[i]==0) // si le bit est  0 on le passe  1 t on met la retenue  0
		    {
			tableau[i]=1;
			a=0;
		    }
	    }
	// si il y'a un overflow, on renvoie la retenue pour le dtecter
	return a;
    }	
    


  
    // mthode pour gnrer tous les abres binaires en vitant les symtries
    Vector v2 = new Vector();
    private void recur(int[] tableau,int h, int []tab, int indice) 
    {
	int[] t=new int[tableau.length*2]; // on cre un tableau qui va contenir tous les bits qui correspondent  la hauteur
	
	for(int i=0;i<tableau.length*2;i++) // on parcours le tableau de l'tage suprieur. Si il y'a un 0 au dessus cela signifie que les deux fils de ce 0 dans cette hauteur ne devront pas etre utilis on met donc un 2 pour les deux fils ce qui signifie une interdiction, sinon on met un 0 pour dire qu'on a le droit de compter
	    {
	    	if (tableau[i/2]==0 || tableau[i/2]==2) t[i]=2;
	    	else t[i]=0;
	    }
	
	int retenue=incrementer(t); // on fixe la retenue tout de suite en incrmentant au lieu de 0 de manire  ce que tous les arbres soient de la hauteur donne. Sinon, si on fixe la retenue  0 cela permet d'avoir un arbre de plus petite hauteur. En effet, si en incrmentant la retenue passe dja  1 c'est que cette hauteur ci est rempli de 2 et ne peut etre utilise, et donc que l'on aura jamais un arbre de la hauteur demande, il ne sert  rien de continuer la rcursion.
	
	while(retenue!=1) 
	    {
		// on ajoute dans tab la portion de l'abre calcule  cette hauteur, de manire  pouvoir renvoyer tab aprs
	    	for(int i=0;i<t.length;i++) 
		    {
			if (t[i]!=2) tab[indice+i]=t[i];
			else tab[indice+i]=0; // si la hauteur contient un 2, ont met un 0  la place car le 2 sert juste  la gestion interne
		    }
	    	if (h>2) recur(t,h-1, tab, indice+t.length); // si on est pas encore arriv en bas de l'abre, on appelle la construction sur la hauteur suivante  partir de la hauteur en cours
	    	else {
		    // sinon, si on se trouve  la hauteur 1 de l'arbre (en effet un 1, signifie qu'il y'a deux fils. Ce n'est pas donc pas ncessaire de descendre  la hauteur 0)
		    // on vrifie que l'arbre que l'on s'apprete  ajouter n'est pas dja une symtrie d'un arbre ajoute prcdmment
		    // si ce n'est pas le cas, on l'ajoute
		    if (!estSym(v2, tab,0)) v2.addElement((int[])tab.clone());
		}
		// on incrmente alors la valeur binaire de la hauteur en cours, de manire  parcourir toutes les possiblit
	    	retenue=incrementer(t);
		// quand on arrive au bout des possiblits pour cette hauteur il y'a une retenue et on revient  la fonction qui a appelle celle ci
	    }
    }
	
	
	
    
	
}	
