package structuresgraphique;

import java.util.Vector;


public class ListeStockage implements Cloneable
{
	private Vector sonContenu=null;
	
	/**
	 * Classe dfinissant une liste de stockage pour les sommets et les artes.
	 */
	public ListeStockage()
	{
		sonContenu=new Vector();
	}
	
	/**
	 * Mthode permettant d'ajouter un objet Stockage  la liste.
	 * @param telS L'objet Stockage  ajouter.
	 */
	public void addStockage(Stockage telS)
	{
		sonContenu.addElement(telS);
	}
	
	/**
	 * Mthode permettant d'obtenir un objet Stockage de la liste.
	 * @return L'objet Stockage demand, null si telRang dpasse la capacit de la liste.
	 */
	public Stockage getStockage(int telRang)
	{
		if(telRang<size())
			return (Stockage)sonContenu.get(telRang);
		else
			return null;
	}
	
	/**
	 * Retourne la taille de la liste
	 * @return La taille de la liste
	 */
	public int size()
	{
		return sonContenu.size();
	}
	
	public boolean removeStockage(Stockage telS)
	{
		return sonContenu.removeElement(telS);
	}
	
	public boolean removeStockage(int telRang)
	{
		if(telRang<size())
		{
			sonContenu.remove(telRang);
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public void setListeStockage(Stockage[] telleListe)
	{
		sonContenu=new Vector();
		
		for(int i=0; i<telleListe.length; i++)
			sonContenu.addElement(new Stockage(telleListe[i].getNom(), telleListe[i].getContenu()));
	}
	
	public Object clone()
	{
		ListeStockage leClone=new ListeStockage();
		int leNb=size();
		
		for(int i=0; i<leNb; i++)
		{
			leClone.addStockage(new Stockage(getStockage(i).getNom(), getStockage(i).getContenu()));
		}
		
		return leClone;
	}
	
	public boolean egal(ListeStockage telleL)
	{
		int leNb=telleL.size();
		boolean egal=true;
		
		if(leNb!=size())
			return false;
			
		for(int i=0; i<leNb && egal; i++)
		{
			if(!getStockage(i).egal(telleL.getStockage(i)))
				egal=false;
		}
		
		return egal;
	}
	
}
