package editeurarbre.ihmediteurarbre;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Frame;
import java.awt.Component;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import structuresgraphique.ListeStockage;
import structuresgraphique.Stockage;
import editeurarbre.ChangementColSupprListener;

public class FenetreEditeurArbre extends JDialog implements ActionListener, ChangementColSupprListener, WindowListener
{
	private ListeStockage saListeStockage=null;
	private ListeStockage saListeStockageCopy=null;
	private JPanel sonPanelPere=new JPanel();
	private PanelEditeurArbre sonPanelEditeurArbre=null;
	private JButton sonBoutonValider=new JButton("Valider");
	private JButton sonBoutonAnnuler=new JButton("Annuler");
	private JButton sonBoutonAppliquer=new JButton("Appliquer");
	private ToolBarEditeurArbre saToolBarEditeurArbre=new ToolBarEditeurArbre(this);
	private boolean sonBoolActivated=false;
	
	
	public FenetreEditeurArbre(ListeStockage telleListeStockage, String telTitre, boolean telBoolPremierIsRemovable) throws NullPointerException
	{
		super.setTitle(telTitre);
		
		if(telleListeStockage==null)
			throw new NullPointerException("La liste ne doit pas etre null!");
		
		saListeStockage=telleListeStockage;
		saListeStockageCopy=(ListeStockage)telleListeStockage.clone();
		
		
		//windowListener
		super.addWindowListener(this);
		
		// Content Pane
		this.setContentPane(sonPanelPere);
		
		//layout du panel pere
		sonPanelPere.setLayout(new BorderLayout());
		
		
		//remplissage du panel pere
		sonPanelEditeurArbre=new PanelEditeurArbre(this, telBoolPremierIsRemovable);
		sonPanelPere.add(sonPanelEditeurArbre, BorderLayout.CENTER);
		addPanelBoutons();
		sonPanelPere.add(saToolBarEditeurArbre, BorderLayout.NORTH);
		
		sonPanelEditeurArbre.getTableau().addChangementColSupprListener(this);
		
		init();
		
		super.setResizable(false);
		super.pack();
		
		double laLargEcran=java.awt.Toolkit.getDefaultToolkit().getScreenSize().getWidth();
		double laHautEcran=java.awt.Toolkit.getDefaultToolkit().getScreenSize().getHeight();
		super.setLocation((int)(laLargEcran-super.getWidth())/2, (int)(laHautEcran-super.getHeight())/2);
		
		super.setVisible(true);
		sonBoolActivated=true;
	}
	
	public void init()
	{
		//boutons
		sonBoutonValider.setEnabled(false);
		sonBoutonAppliquer.setEnabled(false);
		updateStatusBoutonTousAucun();
	}
	
	public ListeStockage getListeStockageCopy()
	{
		return saListeStockageCopy;
	}
	
	private void addPanelBoutons()
	{
		JPanel lePanelBouton=new JPanel(new GridLayout(1, 3));
		sonBoutonAnnuler.addActionListener(this);
		sonBoutonValider.addActionListener(this);
		sonBoutonAppliquer.addActionListener(this);
		lePanelBouton.add(sonBoutonValider);
		lePanelBouton.add(sonBoutonAnnuler);
		lePanelBouton.add(sonBoutonAppliquer);
		sonPanelPere.add(lePanelBouton, BorderLayout.SOUTH);
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() instanceof JButton)
		{
			if(e.getSource()==sonBoutonAnnuler)
			{
				actionBoutonAnnuler();
			}
			else
			{
				if(e.getSource()==sonBoutonValider)
				{
					actionBoutonValider();
				}
				else
				{
					if(e.getSource()==sonBoutonAppliquer)
						actionBoutonAppliquer();
				}
			}
		}
	}
	
	private void actionBoutonAnnuler()
	{
		//on remet la copy a l original
		saListeStockageCopy.setListeStockage(getTabStockage(saListeStockage));
		sonPanelEditeurArbre.getTableau().revalidate();
		
		fermeFenetre();
	}
	
	public void actionBoutonUndo()
	{
		//on remet la copy a l original
		saListeStockageCopy.setListeStockage(getTabStockage(saListeStockage));
		saToolBarEditeurArbre.setUndoEnabled(false);
		sonBoutonAppliquer.setEnabled(false);
		sonBoutonValider.setEnabled(false);
		updateStatusBoutonTousAucun();
		sonPanelEditeurArbre.getTableau().synchronizeBoolSupprAvecContenu();
		sonPanelEditeurArbre.getTableau().revalidate();
		sonPanelEditeurArbre.getTableau().repaint();
	}
	
	private void updateStatusBoutonTousAucun()
	{
		if(sonPanelEditeurArbre.getTableau().getNbLigne()<=editeurarbre.Constantes.NB_ELT_MIN)
			saToolBarEditeurArbre.setTousAucunEnabled(false);
		else
			saToolBarEditeurArbre.setTousAucunEnabled(true);
	}
	
	private void actionBoutonAppliquer()
	{
		//on recopie la ListeStockage copy sur la ListeStockage original
		//on vire les lignes totalement blanche
		Stockage leSVide=new Stockage();
		for(int i=0; i<saListeStockageCopy.size(); i++)
		{
			if(leSVide.egal(saListeStockageCopy.getStockage(i)))
			{
				saListeStockageCopy.removeStockage(i);
				i--;
			}
		}
		
		Stockage[] laListe=getTabStockage(saListeStockageCopy);
		saListeStockage.setListeStockage(laListe);
		
		//on remet la liste a l original sans changer la reference!
		saListeStockageCopy.setListeStockage(laListe);
		
		//on desactive les boutons
		sonBoutonAppliquer.setEnabled(false);
		sonBoutonValider.setEnabled(false);
		saToolBarEditeurArbre.setUndoEnabled(false);
	}
	
	private Stockage[] getTabStockage(ListeStockage telleListe)
	{
		int leNb=telleListe.size();
		Stockage[] laListe=new Stockage[leNb];
		
		for(int i=0; i<leNb; i++)
		{
			laListe[i]=new Stockage(telleListe.getStockage(i).getNom(), 
									telleListe.getStockage(i).getContenu());
		}
		
		return laListe;
	}
	
	private void actionBoutonValider()
	{
		actionBoutonAppliquer();
		fermeFenetre();
	}
	
	private void fermeFenetre()
	{
		this.dispose();
		sonBoolActivated=false;
	}
	
	public void ajouteLigneTableau()
	{
		sonPanelEditeurArbre.getTableau().ajouteEltTableau(new Stockage());
		saToolBarEditeurArbre.setUndoEnabled(true);
		sonBoutonAppliquer.setEnabled(true);
		sonBoutonValider.setEnabled(true);
		updateStatusBoutonTousAucun();
	}
	
	public boolean retireLigneTableau(int telRang)
	{
		boolean b = sonPanelEditeurArbre.getTableau().retireEltTableau(telRang);
		
		saToolBarEditeurArbre.setUndoEnabled(true);
		sonBoutonAppliquer.setEnabled(true);
		sonBoutonValider.setEnabled(true);
		updateStatusBoutonTousAucun();
				
		return b;
	}
	
	public int getNbLignesTableau()
	{
		return sonPanelEditeurArbre.getTableau().getNbLigne();
	}
	
	public boolean isSelected(int telleLigne)
	{
		return sonPanelEditeurArbre.getTableau().isSelected(telleLigne);
	}
	
	public void selectAll()
	{
		sonPanelEditeurArbre.getTableau().selectAll();
	}
	
	public void deselectAll()
	{
		sonPanelEditeurArbre.getTableau().deselectAll();
	}
	
	public void changementColSupprTable(int telleColonne)
	{
		if(telleColonne==editeurarbre.Constantes.SUPPR)
		{
			//la colonne suppr a change
			if(sonPanelEditeurArbre.getTableau().aucuneCaseSupprSelectionnee())
			{
				saToolBarEditeurArbre.setSupprEnabled(false);
				saToolBarEditeurArbre.setTousAucunSelected(false);
			}
			else
				saToolBarEditeurArbre.setSupprEnabled(true);
		}
		else
		{
			//on met a jour l etat des boutons valider et appliquer
			if(!saListeStockage.egal(saListeStockageCopy))
			{
				sonBoutonValider.setEnabled(true);
				sonBoutonAppliquer.setEnabled(true);
				saToolBarEditeurArbre.setUndoEnabled(true);
			}
			else
			{
				sonBoutonValider.setEnabled(false);
				sonBoutonAppliquer.setEnabled(false);
				saToolBarEditeurArbre.setUndoEnabled(false);
			}
		}
	}
	
	public void windowOpened(WindowEvent e){sonBoolActivated=true;}
	public void windowClosed(WindowEvent e)
	{
		init();
		saToolBarEditeurArbre.init();
	}
	public void windowIconified(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}
	public void windowActivated(WindowEvent e)
	{
		if(!sonBoolActivated && sonPanelEditeurArbre!=null)
		{
			actionBoutonUndo();
		}
		
		sonBoolActivated=true;
	}
	public void windowDeactivated(WindowEvent e){}
	public void windowClosing(WindowEvent e)
	{
		if(!saListeStockage.egal(saListeStockageCopy))
		{
			int leRes=JOptionPane.showConfirmDialog(this, "Etes-vous sr(e) de vouloir appliquer les modifications?", "Confimation", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
			
			if(leRes==JOptionPane.YES_OPTION)
				this.actionBoutonValider();
			else
				this.actionBoutonAnnuler();
		}
	}
	
	public void verifieEtatBoutons()
	{
		if(saListeStockage.egal(saListeStockageCopy))
		{
			init();
			saToolBarEditeurArbre.init();
		}
	}
	
	/*public void afficheContenu()
	{
		sonPanelEditeurArbre.getTableau().afficheContenu();
	}*/
}
