package ihm;

import moduleaide.FenetreAide;
import parametres.*;
import moduleparametrage.*;


import java.awt.*;
import java.awt.Font;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;


public class BarreMenu extends JMenuBar implements ActionListener, ItemListener
{
	private JMenu sonMenuFichier = new JMenu("Fichier");
    private JMenuItem sonOuvrir = new JMenuItem("Charger");
    private JMenuItem sonEnregistrer = new JMenuItem("Enregistrer");
    private JMenuItem sonEnregistrerTout = new JMenuItem("Enregistrer tout");
    private JMenuItem sonChargerTout = new JMenuItem("Charger tout");
    private JMenuItem sonFermerTout = new JMenuItem("Fermer tout");
    private JMenuItem sonQuitter = new JMenuItem("Quitter");

	private JMenu sonMenuAffichage = new JMenu("Affichage");
    private JMenuItem saCreation = new JMenuItem("Onglet creation");
    private JMenuItem sonExecution = new JMenuItem("Onglet execution");
    private JMenuItem sonParametrage = new JMenuItem("Onglet parametrage");

	private JMenu sonMenuFonction = new JMenu("Fonction");
    private JMenu sonSousMenuGeneration = new JMenu("Generation");
    private JMenuItem sonTsArbreHauteur = new JMenuItem("Tous les arbres de hauteur H");
    private JMenuItem sonTsArbreNoeud = new JMenuItem("Tous les arbres ayant N noeuds internes");
    private JMenuItem sonAleaArbreHauteur = new JMenuItem("Un arbre aleatoire de hauteur H");
    private JMenuItem sonAleaArbreNoeud = new JMenuItem("Un arbre aleatoire ayant au max N noeuds");

	private JMenu sonMenuOptions = new JMenu("Options");
    private JMenu sonSousMenuColoration = new JMenu("Coloration");
    private JMenuItem saRacine = new JMenuItem("Racine");
    private JMenuItem saFeuille = new JMenuItem("Feuilles");
    private JMenuItem sonSomSelec = new JMenuItem("Sommets Selectionnes");
    private JMenuItem sonSomSuivi = new JMenuItem("Sommets Suivis");
    private JMenuItem sonResteSom = new JMenuItem("Restes Sommets");
    private JMenuItem saCourbe = new JMenuItem("Courbe Ordonancement");
    private JMenu sonSousMenuCreation = new JMenu("Creation");
    private JCheckBoxMenuItem sonAntiAliasing = new JCheckBoxMenuItem("Anti-Aliasing");
    private JMenuItem saLargeur = new JMenuItem("Largeur Sommet");
    private JMenu sonSousMenuThread = new JMenu("Thread");
    private JMenuItem saVitesseThread = new JMenuItem("Vitesse thread");


    private JMenu sonMenuAide = new JMenu("Aide");
    private JMenuItem sonAide = new JMenuItem("Aide");

	//private Font saPolice = new Font ("Arial",1,10);

    private IHM sonIhm = null;
    private JFileChooser saBoiteFichier = new JFileChooser();
    private JColorChooser saBoiteCouleur = new JColorChooser();
	
	public BarreMenu(IHM fenetre)
    {
        sonIhm = fenetre;

        //menu fichier
        sonMenuFichier.setFont(Constantes.POLICE);
        sonOuvrir.setFont(Constantes.POLICE);
        sonOuvrir.addActionListener(this);
        sonOuvrir.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,ActionEvent.ALT_MASK));
        
        sonEnregistrer.setFont(Constantes.POLICE);
        sonEnregistrer.addActionListener(this);
        sonEnregistrer.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,ActionEvent.ALT_MASK));
        
        sonEnregistrerTout.addActionListener(this);
        sonEnregistrerTout.setFont(Constantes.POLICE);
        sonEnregistrerTout.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,ActionEvent.ALT_MASK));
        
        sonChargerTout.addActionListener(this);
        sonChargerTout.setFont(Constantes.POLICE);
        sonChargerTout.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T,ActionEvent.ALT_MASK));
        
        sonFermerTout.addActionListener(this);
        sonFermerTout.setFont(Constantes.POLICE);
        sonFermerTout.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,ActionEvent.ALT_MASK));
        
        sonQuitter.setFont(Constantes.POLICE);
        sonQuitter.addActionListener(this);
        sonQuitter.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,ActionEvent.ALT_MASK));

        sonMenuFichier.add(sonOuvrir);
        sonMenuFichier.add(sonChargerTout);
        sonMenuFichier.addSeparator();
        sonMenuFichier.add(sonEnregistrer);
	    sonMenuFichier.add(sonEnregistrerTout);
        sonMenuFichier.addSeparator();
        sonMenuFichier.add(sonFermerTout);
        sonMenuFichier.add(sonQuitter);
        

        

        //menu affichage
		sonMenuAffichage.setFont(Constantes.POLICE);
        saCreation.setFont(Constantes.POLICE);
        saCreation.addActionListener(this);
        saCreation.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,ActionEvent.CTRL_MASK));
        
        sonExecution.setFont(Constantes.POLICE);
        sonExecution.addActionListener(this);
        sonExecution.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E,ActionEvent.CTRL_MASK));
        
        sonParametrage.setFont(Constantes.POLICE);
        sonParametrage.addActionListener(this);
        sonParametrage.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,ActionEvent.CTRL_MASK));
        
        sonMenuAffichage.add(saCreation);
        sonMenuAffichage.add(sonExecution);
        sonMenuAffichage.add(sonParametrage);

        //menu fonction
		sonMenuFonction.setFont(Constantes.POLICE);
        sonSousMenuGeneration.setFont(Constantes.POLICE);
        sonTsArbreHauteur.setFont(Constantes.POLICE);
        sonTsArbreNoeud.setFont(Constantes.POLICE);
        sonAleaArbreHauteur.setFont(Constantes.POLICE);
        sonAleaArbreNoeud.setFont(Constantes.POLICE);
        sonSousMenuGeneration.add(sonTsArbreHauteur);
        sonSousMenuGeneration.add(sonTsArbreNoeud);
        sonSousMenuGeneration.addSeparator();
        sonSousMenuGeneration.add(sonAleaArbreHauteur);
        sonSousMenuGeneration.add(sonAleaArbreNoeud);
        sonMenuFonction.add(sonSousMenuGeneration);
        
        //menu options
		sonMenuOptions.setFont(Constantes.POLICE);

        sonSousMenuColoration.setFont(Constantes.POLICE);
		//sonArete.setFont(saPolice);
        //sonArete.addActionListener(this);
		saRacine.setFont(Constantes.POLICE);
        saRacine.addActionListener(this);
		saFeuille.setFont(Constantes.POLICE);
        saFeuille.addActionListener(this);
		sonSomSelec.setFont(Constantes.POLICE);
        sonSomSelec.addActionListener(this);
		sonSomSuivi.setFont(Constantes.POLICE);
        sonSomSuivi.addActionListener(this);
		sonResteSom.setFont(Constantes.POLICE);
        sonResteSom.addActionListener(this);
		saCourbe.setFont(Constantes.POLICE);
        saCourbe.addActionListener(this);
//        sonSousMenuColoration.add(Constantes.POLICE);
        sonSousMenuColoration.add(saRacine);
        sonSousMenuColoration.add(saFeuille);
        sonSousMenuColoration.add(sonSomSelec);
        sonSousMenuColoration.add(sonSomSuivi);
        sonSousMenuColoration.add(sonResteSom);
        sonSousMenuColoration.add(saCourbe);
        sonMenuOptions.add(sonSousMenuColoration);




        sonSousMenuCreation.setFont(Constantes.POLICE);
        sonAntiAliasing.setFont(Constantes.POLICE);
        sonAntiAliasing.setSelected(sonIhm.getPanelBase().getAntiAliasState());
        sonAntiAliasing.addItemListener(this);
        saLargeur.setFont(Constantes.POLICE);
        saLargeur.addActionListener(this);
        sonSousMenuCreation.add(sonAntiAliasing);
        sonSousMenuCreation.add(saLargeur);
        sonMenuOptions.add(sonSousMenuCreation);
        
        sonAleaArbreHauteur.addActionListener(this);
        sonAleaArbreNoeud.addActionListener(this);
        sonTsArbreHauteur.addActionListener(this);
        sonTsArbreNoeud.addActionListener(this);

        sonSousMenuThread.setFont(Constantes.POLICE);
        saVitesseThread.setFont(Constantes.POLICE);
        saVitesseThread.addActionListener(this);
        sonMenuOptions.add(saVitesseThread);
        sonMenuOptions.add(sonSousMenuThread);
        sonSousMenuThread.add(saVitesseThread);

        //menu aide
        sonMenuAide.setFont(Constantes.POLICE);
        sonAide.setFont(Constantes.POLICE);
        sonAide.addActionListener(this);
        sonAide.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H,ActionEvent.ALT_MASK));
        sonMenuAide.add(sonAide);

		add(sonMenuFichier);
		add(sonMenuAffichage);
		add(sonMenuFonction);
		add(sonMenuOptions);
        add(sonMenuAide);
		
    } // fin du consctructeur

	/* juste une petite mthode pour afficher l'erreur sur les nombres */
	private void erreur_nombre (int limite)
	{
		JOptionPane.showMessageDialog(sonIhm,"Veuillez entrer un nombre >= " + limite,"Erreur",JOptionPane.ERROR_MESSAGE);
	}

    public void changeCouleur(Color ancienne,int indiceLabel)
    {
        Color couleur;
        couleur = saBoiteCouleur.showDialog(sonIhm," Choix D'une Nouvelle Couleur ",ancienne);
        if(couleur != null && couleur != ancienne)
        {
            sonIhm.getSonPanneauParametrage().getPanneauCentre().getJLabel(indiceLabel).setBackground(couleur);
            
            /*if(indiceLabel == 1)
            {
               // Parametrages.setCoulAretes(couleur);
             	//sonIhm.getPanelBase 
            }*/
            
            // Couleur des racines
            if(indiceLabel == 3)
            {      
                Parametrages.setCoulRacine(couleur);
                sonIhm.getPanelBase().majColorRacine(couleur);
            }
            
            // Couleur des feuilles
            if(indiceLabel == 5)
            {
                Parametrages.setCoulFeuilles(couleur);
                sonIhm.getPanelBase().majColorFeuilles(couleur);
            }
            if(indiceLabel == 7)
                Parametrages.setCoulSelection(couleur);
            if(indiceLabel == 9)
                Parametrages.setCoulSuivi(couleur);
                
			// Couleur des autres sommets
            if(indiceLabel == 11)
        	{
                Parametrages.setCoulSommets(couleur);
                sonIhm.getPanelBase().majColorAutresSommets(couleur);
            }
            if(indiceLabel == 13)
                Parametrages.setCoulCourbe(couleur);
        }
    }

	public void actionPerformed(ActionEvent a)
    {
    	// Affiche la fenetre d'aide
        if(a.getSource() == sonAide)
        {
			FenetreAide fenetreAide = new FenetreAide(sonIhm);
			return;
        }
        
        if(a.getSource() == sonQuitter)
        {
 			int ret=JOptionPane.showConfirmDialog(sonIhm,"Etes-vous sur de vouloir quitter ?","Confirmation ?",JOptionPane.YES_NO_OPTION);
		
			if(ret==JOptionPane.YES_OPTION)
				System.exit(1);          	
        }
        
        // Pour changer d'onglets
        if(a.getSource() == saCreation)
            sonIhm.getPanneauOnglet().setSelectedIndex(0);
        if(a.getSource() == sonExecution)
            sonIhm.getPanneauOnglet().setSelectedIndex(1);
        if(a.getSource() == sonParametrage)
            sonIhm.getPanneauOnglet().setSelectedIndex(2);
            
        // Ouvrir un arbre
        if(a.getSource() == sonOuvrir)
        {
        	JFileChooser saBoiteFichier = new JFileChooser();
        	saBoiteFichier.addChoosableFileFilter(new UnFiltreLeda());
        	
            int resultat = saBoiteFichier.showOpenDialog(sonIhm);
            File fichier = saBoiteFichier.getSelectedFile();
            if(resultat == JFileChooser.APPROVE_OPTION)
                sonIhm.getPanelBase().chargerNouveau(fichier);
            //if(resultat == JFileChooser.CANCEL_OPTION)
            //    System.out.println("ANNULATION");
        }
        
        // Enregistrer un arbre
        if(a.getSource() == sonEnregistrer)
        {
        	JFileChooser saBoiteFichier = new JFileChooser();
            saBoiteFichier.addChoosableFileFilter(new UnFiltreLeda());
            
            int resultat = saBoiteFichier.showSaveDialog(sonIhm);
            File fichier = saBoiteFichier.getSelectedFile();
            if(resultat == JFileChooser.APPROVE_OPTION)
                sonIhm.getPanelBase().sauvegarderCourant(fichier);
            
            //if(resultat == JFileChooser.CANCEL_OPTION)
            //    System.out.println("ANNULATION");
        }
        
        // Enregistrer tout les arbres ouverts dans un dossier
        if(a.getSource() == sonEnregistrerTout)
        {
        	JFileChooser leChoix = new JFileChooser();
        	
        
        	leChoix.setDialogType(JFileChooser.SAVE_DIALOG);
        	leChoix.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        	int resultat = leChoix.showSaveDialog(sonIhm);
        	
        	if(resultat == JFileChooser.APPROVE_OPTION)
        		sonIhm.getPanelBase().sauvegarderTout(leChoix.getSelectedFile());
        }
        
        // Charger tout
        if(a.getSource() == sonChargerTout)
        {
         	JFileChooser leChoix = new JFileChooser();
         	
        	leChoix.setDialogType(JFileChooser.OPEN_DIALOG);
        	leChoix.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        	int resultat = leChoix.showOpenDialog(sonIhm);
        	
        	if(resultat == JFileChooser.APPROVE_OPTION)
        		sonIhm.getPanelBase().chargerTout(leChoix.getSelectedFile());       	
        }
        
        // Diametre des sommets
        if(a.getSource() == saLargeur)
        {
            String message = "Largeur des sommets en pixels";
            String resultat = JOptionPane.showInputDialog(sonIhm, message);
            if(resultat != null)
            {
                try
                {
                    int valeur = Integer.parseInt(resultat);
                    Parametrages.setDiametreSommets(valeur);
                    sonIhm.getSonPanneauParametrage().getPanneauCentre().setSaLargeurTexte(valeur+"");
                    sonIhm.getPanelBase().majDiametreSommets(valeur);
                }
                catch(NumberFormatException e)
                {
					erreur_nombre (0);
                }
            }
        }
        //if(a.getSource() == sonArete)
            //changeCouleur(Parametrages.getCoulAretes(),1);
        if(a.getSource() == saRacine)
            changeCouleur(Parametrages.getCoulRacine(),3);
        if(a.getSource() == saFeuille)
            changeCouleur(Parametrages.getCoulFeuilles(),5);
        if(a.getSource() == sonSomSelec)
            changeCouleur(Parametrages.getCoulSelection(),7);
        if(a.getSource() == sonSomSuivi)
            changeCouleur(Parametrages.getCoulSuivi(),9);
        if(a.getSource() == sonResteSom)
            changeCouleur(Parametrages.getCoulSommets(),11);
        if(a.getSource() == saCourbe)
            changeCouleur(Parametrages.getCoulCourbe(),13);

        if(a.getSource() == saVitesseThread)
        {
            String message = "Vitesse des threads entre 500 et 5000 millisecondes";
            String resultat = JOptionPane.showInputDialog(sonIhm, message);
            if(resultat != null)
            {
                try
                {
                    int valeur = Integer.parseInt(resultat);
                    if(valeur < 500 || valeur > 5000)
                        JOptionPane.showMessageDialog(sonIhm,"Veuillez entrer un nombre entre 500 et 5000","Erreur",JOptionPane.ERROR_MESSAGE);
                    else
                    {
                        Parametrages.setVitesse(valeur);
                        sonIhm.getSonPanneauParametrage().getPanneauSud().setSonAffichage(valeur+"");
                        sonIhm.getSonPanneauParametrage().getPanneauSud().setCurseur(valeur);
                    }
                }
                catch(NumberFormatException e)
                {
					erreur_nombre (0);
                }
            }
        }
        
        // Generation d'un Arbre aleatoire de Hauteur H   
		if(a.getSource() == sonAleaArbreHauteur)
		{
			String leRetour = JOptionPane.showInputDialog(sonIhm,"Entrer la hauteur desiree");
			
			if(leRetour != null)
			{
				try
				{
					int laHauteur=Integer.parseInt(leRetour);
					
					if(laHauteur>=0)
						sonIhm.getPanelBase().genAleaH(laHauteur);
					else erreur_nombre (0);
				}
			    catch(NumberFormatException e)
                {
					erreur_nombre (0);
                }	
			}
			
		}
		
		// Un arbre aleatoire ayant au max n noeuds
		if(a.getSource() == sonAleaArbreNoeud)
		{
			String leRetour = JOptionPane.showInputDialog(sonIhm,"Entrer le nombre de noeuds desires");
			
			if(leRetour != null)
			{
				try
				{
					int leNbNoeud=Integer.parseInt(leRetour);
					
					if(leNbNoeud%2 ==0)
					{
						leNbNoeud--;
						JOptionPane.showMessageDialog(sonIhm,"Le nombre de noeud saisi etant pair, la valeur est ramenee a " + leNbNoeud,"Avertissement",JOptionPane.WARNING_MESSAGE);
					}
					
					if(leNbNoeud>=1)
						sonIhm.getPanelBase().genAleaT(leNbNoeud);
					else erreur_nombre (1);
				}
			    catch(NumberFormatException e)
                {
					erreur_nombre (1);
                }	
			}	
		}
		
		// Generation de tous les arbres de hauteur h
		if(a.getSource() == sonTsArbreHauteur)
		{
			String leRetour = JOptionPane.showInputDialog(sonIhm,"Entrer la hauteur desiree");
			
			if(leRetour != null)
			{
				try
				{
					int laHauteur=Integer.parseInt(leRetour);
					
					if(laHauteur>=0)
						sonIhm.getPanelBase().genTousH(laHauteur);
					else erreur_nombre (0);
				}
			    catch(NumberFormatException e)
                {
					erreur_nombre (0);
                }	
			}			
		}
		
		// Generation Tous Arbres Ayant Au Max N Noeuds
		if(a.getSource() == sonTsArbreNoeud)
		{
			String leRetour = JOptionPane.showInputDialog(sonIhm,"Entrer le nombre de noeuds desires");
			
			if(leRetour != null)
			{
				try
				{
					int leNbNoeud=Integer.parseInt(leRetour);
					
					if(leNbNoeud>0)
						sonIhm.getPanelBase().genTousT(leNbNoeud);
					else erreur_nombre (1);
				}
			    catch(NumberFormatException e)
                {
					erreur_nombre (1);
                }	
			}
			
		}
		
		// Fermer tout
		if(a.getSource() == sonFermerTout)
		{
			int reponse = JOptionPane.showConfirmDialog(sonIhm,"Etes vous sur de fermer tout les arbres ?","Confirmation ?", JOptionPane.YES_NO_OPTION);
			
			if(reponse == JOptionPane.YES_NO_OPTION) {
				sonIhm.getSonPanneauExecution ().getLanceur ().arret ();
				try {
					sonIhm.getSonPanneauExecution ().getLanceur ().join ();
				}
				catch (InterruptedException e) {}
				sonIhm.getPanelBase().fermerTout();
				sonIhm.efface_exec ();
				sonIhm.getSonPanneauExecution ().getPanneauAffichage ().getPanelArbre().setArbre (null);
				sonIhm.getSonPanneauExecution ().getToolBar ().activerExecution ();
				sonIhm.getSonPanneauExecution ().getToolBar ().activerPrev (false);
				sonIhm.getSonPanneauExecution ().getToolBar ().activerNext (false);
			}
		}		
            
	}

	public void itemStateChanged(ItemEvent e)
	{
		if(e.getSource() == sonAntiAliasing)
		{
			sonIhm.getPanelBase().setAntiAlias(sonAntiAliasing.isSelected());
			sonIhm.getSonPanneauExecution().getPanneauAffichage().getPanelCourbe().setAntiAlias(sonAntiAliasing.isSelected());
			sonIhm.getSonPanneauParametrage().getPanneauCentre().setCheckBoxAntiAlias(sonAntiAliasing.isSelected());
		}	
	}
	
	public void setCheckBoxAntiAliasing(boolean b)
	{
		sonAntiAliasing.setSelected(b);
	}
}

class UnFiltreLeda extends javax.swing.filechooser.FileFilter//implements FilenameFilter
{
	public boolean accept(File file)
	{
		return file.isDirectory() || file.getName().endsWith(".leda");
	}
	
	public String getDescription()
	{
		return "Fichiers LEDA (*.leda)";	
	}
}
