package ihm;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

import moduleexecution.*;
import modulecreation.*;
import moduleparametrage.*;
import conversion.*;

import structuresgraphique.UnArbreGraphique;
import structuresdonnees.ABP;

public class IHM  extends JFrame implements ChangeListener,WindowListener {

	private JTabbedPane sonPanelOnglets = null;
	private BarreMenu saBarreMenu = null; 
	// Les panels du panel  onglets
	private UnPanelDessinBase sonPanelDessinBase;
	private PanneauExecution sonPanneauExecution;
    private PanneauParametrage sonPanneauParametrage;
	private boolean prev_est_creat;

	public IHM() {
		
		/* Proprits de la fentre */

		setTitle("Arbres Binaires");
		
		// Cration des panneaux
		sonPanelOnglets = new JTabbedPane();
		prev_est_creat = true;
		
		
		// Police
		if(System.getProperty("os.name").toLowerCase().indexOf("win")!=-1)
			Constantes.POLICE = new Font ("Arial",1,10);
		else
			Constantes.POLICE = sonPanelOnglets.getFont();
		
		sonPanelOnglets.setFont(Constantes.POLICE);			
		
		sonPanelDessinBase = new UnPanelDessinBase(this);
		sonPanneauExecution=new PanneauExecution();
		sonPanneauParametrage = new PanneauParametrage(this);
		saBarreMenu = new BarreMenu(this);
		
		// Ajouts des onglets
		sonPanelOnglets.add("Creation",sonPanelDessinBase); 
        sonPanelOnglets.add("Execution",sonPanneauExecution);
		sonPanelOnglets.add("Parametrage",sonPanneauParametrage);
		getContentPane().add(sonPanelOnglets);
				
		// Barre de menu
		setJMenuBar(saBarreMenu);

        sonPanelOnglets.addChangeListener(this);
        this.addWindowListener(this);
        this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		
		setSize(1000,600);	
		setVisible(true);
		
	}

	/* efface les donnes d'un arbre dans excution si on modifie l'abre
	 * en cours d'tude */
	public void efface_exec ()
	{
		sonPanneauExecution.getPanneauAffichage().getPanelCourbe().setCourbe(null);
		sonPanneauExecution.getPanneauAffichage().getZoneRapport().setText("");
		sonPanneauExecution.getToolBar().activerNext(false);
		sonPanneauExecution.getToolBar().activerPrev(false);
	}
	
    // evenements de l'onglet mise a jour de l'arbre courant:
    public void stateChanged(ChangeEvent e)
    {
    	if(sonPanelDessinBase.getCurrentArbreGraphique()!=null)
    	{
        	ABP abp_tmp;
    		UnArbreGraphique telArbre;
    	
			/* on calcul le nombre de strahler (au cas o il aurai chang).
			 * On ne le calcul que si on vient du panel cration et qu'on 
			 * va vers le panem xcution */
			if (prev_est_creat && (sonPanelOnglets.getSelectedIndex () == 1)) {
				UnArbreGraphique tmp = sonPanelDessinBase.getCurrentArbreGraphique();
				abp_tmp = Conversion.graphicToDonnees (sonPanelDessinBase.getCurrentArbreGraphique());
				abp_tmp.calculStrahler (1);
				telArbre=Conversion.donneeToGraphic (abp_tmp);
				telArbre.getSonSommet ().setPosition (tmp.getSonSommet ().getX(), tmp.getSonSommet ().getY ());
				sonPanelDessinBase.getCurrentPanelDessin().setSonArbre(telArbre);
				sonPanelDessinBase.getCurrentArbreGraphique().maj_x_y();
				prev_est_creat = false;
			}
        	/* fin de mise  jour de Strahler */
			/* si on est sur "Cration" alors il faudra penser  changer
			 * strahler quand on ira sur "Excution" mais on ne change
			 * pas quand on viens de "Paramtres" vers "Excution" sauf si
			 * on a t sur Cration avant Paramtres :) */
			if (sonPanelOnglets.getSelectedIndex () == 0)
				prev_est_creat = true;
    	
   		 	sonPanneauExecution.getPanneauAffichage().getPanelArbre().setArbre(sonPanelDessinBase.getCurrentArbreGraphique());
       	 	repaint();
      	}
    }
    
    public JTabbedPane getPanneauOnglet()
    {
        return sonPanelOnglets;
    }
    
    public UnPanelDessinBase getPanelBase()
    {
    	return sonPanelDessinBase;
    }
    
    public BarreMenu getSaBarreMenu()
    {
    	return saBarreMenu;	
    }
    
    public PanneauParametrage getSonPanneauParametrage()
    {
    	return sonPanneauParametrage;
    }
	
	public PanneauExecution getSonPanneauExecution()
	{
		return sonPanneauExecution;
	}
	
	public static void main(String[] args)
	{
		
		IHM a = new IHM();
	}
	
	// Evenements de la fenetre
 	public void windowActivated(WindowEvent e){}
	public void windowClosed(WindowEvent e)
	{
	}
    public void windowClosing(WindowEvent e)
    {
 		int ret=JOptionPane.showConfirmDialog(this,"Etes-vous sur de vouloir quitter ?","Confirmation ?",JOptionPane.YES_NO_OPTION);
		
		if(ret==JOptionPane.YES_OPTION)
			System.exit(1);  

    }
	public void windowDeactivated(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}
	public void windowIconified(WindowEvent e){}
	public void windowOpened(WindowEvent e){}

	
}

