package modulecreation;

import structuresgraphique.UnArbreGraphique;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;

import structuresdonnees.*;
import structuresgraphique.*;
import conversion.*;
import ihm.*;


/**
 * Cette classe regroupe un panel de commande permettant de grer
 * la cration des arbres, et l'affichage graphique de la cration
 * de l'arbre
 */
public class UnPanelDessinBase extends JPanel
{
	private CardLayout gestionnaireDesCartes = new CardLayout();
	private JPanel sonPanelCartes = new JPanel(gestionnaireDesCartes);
	private UnPanelCommandesDessin sonPanelCommandes = null ;
	private IHM papa;
	
	public UnPanelDessinBase(IHM papa)
	{
		super(new BorderLayout());
		this.papa = papa;
		sonPanelCommandes = new UnPanelCommandesDessin(sonPanelCartes, this);
		
		/*ABP telArbre = new ABP(4);
		telArbre.setNoeud(2);
		telArbre.setNoeud(6);
		telArbre.setNoeud(14);
		
		String[] test=new String[2];
		test[0]="titre1";
		test[1]="data1";
		
		String[] test2=new String[2];
		test2[0]="titre2";
		test2[1]="data2";
		
		telArbre.getObjNoeud(1).setInfosNoeud(new Vector());
		telArbre.getObjNoeud(1).getInfosNoeud().add(test);
		
		telArbre.getObjNoeud(2).setInfosArete(new Vector());
		telArbre.getObjNoeud(2).getInfosArete().add(test2);
		
		ABP telArbre2=Conversion.graphicToDonnees(Conversion.donneeToGraphic(telArbre));
		
		//System.out.println ("sauve test");
		Flux leFlux=new Flux("c://test.ll");
		leFlux.ecrire(telArbre2);	
		
		
		UnArbreGraphique ag = Conversion.donneeToGraphic(telArbre2);
		UnPanelDessin leDessin = new UnPanelDessin(ag,this);*/

		//addCard(leDessin);
		sonPanelCommandes.majLabelNbArbre(0);

		add(sonPanelCommandes, BorderLayout.NORTH);
		add(sonPanelCartes,BorderLayout.CENTER);
	}

	/* permet d'obtenir le contexte du pre */
	public IHM getPere () { return papa; }
	/**
	 * Ajoute une carte contenant un panel de dessin
	 * @param telPanelDessin le panel de dessin  ajouter
	 */
	public void addCard(UnPanelDessin telPanelDessin)
	{
		sonPanelCartes.add(new UneScrollbar(telPanelDessin),"");
	}
	
	/**
	 * Ajoute un nouveau panel avec un arbre par dfaut
	 */
	public void addNewPanel()
	{
		addNewPanel(new UnArbreGraphique());
	}

	/**
	 * Ajoute un nouveau panel
	 * @param telArbre l'arbre  afficher sur le panel
	 */
	public void addNewPanel(UnArbreGraphique telArbre)
	{
		addCard(new UnPanelDessin(telArbre, this));
		sonPanelCommandes.nouveauPanel2();;		
	}
	
	/**
	 * Change l'anti-aliasing dans chaque panel
	 * @param telEtat tat de l'anti-aliasing.
	 */
	public void setAntiAlias(boolean telEtat)
	{
		int nb = sonPanelCartes.getComponentCount();
		
		ConstantesCreation.ANTI_ALIAS =telEtat;
	 	
	 	for(int i=0 ; i<nb; i++)
	 	{
	 		((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().repaint();
	 	}
	 }
	 
	 /**
	  * Retourne l'tat de l'anti-aliasing
	  * @return boolean l'tat courant
	  */
	 public boolean getAntiAliasState()
	 {
	 	return ConstantesCreation.ANTI_ALIAS;	
	 }
	 
	/**
	 * Retourne l'arbre qui est actuellement affich
	 * @return l'arbre affich
	 */
	public UnArbreGraphique getCurrentArbreGraphique()
	{
		try
		{
			if(sonPanelCartes.findComponentAt(new Point(0,0))!=null)
				return ((UneScrollbar)sonPanelCartes.findComponentAt(new Point(0,0))).getSonPanel().getSonArbre();
		}
		catch(ClassCastException e)	{}
		
		return null;
	}
	  
	/**
	 * Retourne le panel qui est actuellement actif
	 * @return le panel actif
	 */
	public UnPanelDessin getCurrentPanelDessin()
	{	
		return ((UneScrollbar)sonPanelCartes.findComponentAt(new Point(0,0))).getSonPanel();
	}
	
	/**
	 * Met  jour tous les panels
	 */
	public void repaintAll()
	{
		int nb = sonPanelCartes.getComponentCount();
	 	
	 	for(int i=0 ; i<nb; i++)
	 	{
			((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().repaint();
		}		
	}


	/**
	 * Met  jour la couleur des racines
	 * @param telleCouleur la nouvelle couleur des racines
	 */
	public void majColorRacine(Color telleCouleur)
	{
		if(ConstantesFormes.SOMMET_COLOR_RACINE != telleCouleur)
		{
			ConstantesFormes.SOMMET_COLOR_RACINE = telleCouleur;
			maj_all_arbre();
		}
	}
	
	/**
	 * Retourne la couleur attribue aux racines
	 * @return la couleur de la racine
	 */
	public Color getColorRacine()
	{
		return ConstantesFormes.SOMMET_COLOR_RACINE;
	}
	
	/**
	 * Met  jour la couleur des feuilles
	 * @param telleCouleur la nouvelle couleur des feuilles
	 */
	 public void majColorFeuilles(Color telleCouleur)
	 {
	 	if(ConstantesFormes.SOMMET_COLOR_FEUILLE != telleCouleur)
	 	{
	 		ConstantesFormes.SOMMET_COLOR_FEUILLE = telleCouleur;
	 		maj_all_arbre();
	 	}
	 }
	 
	/**
	 * Retourne la couleur attribue aux feuilles
	 * @return la couleur des feuilles
	 */
	public Color getColorFeuilles()
	{
		return ConstantesFormes.SOMMET_COLOR_FEUILLE;
	}
	 
	/**
	 * Met  jour la couleur des autres sommets
	 * @param telleCouleur la nouvelle couleur des autres sommets
	 */
	 public void majColorAutresSommets(Color telleCouleur)
	 {
	 	if(ConstantesFormes.SOMMET_COLOR_AUTRES != telleCouleur)
	 	{
	 		ConstantesFormes.SOMMET_COLOR_AUTRES = telleCouleur;
	 		maj_all_arbre();
	 	}
	 }
	 
	/**
	 * Retourne la couleur attribue aux autres sommets
	 * @return la couleur des autres sommets
	 */
	public Color getColorAutresSommets()
	{
		return ConstantesFormes.SOMMET_COLOR_AUTRES;
	}	 
	 
	/**
	 * Change la couleur de contour des sommets
	 * @param telleCouleur la nouvelle couleur de contour des sommets
	 */
	public void majColorColorContourSommets(Color telleCouleur)
	{
		if(ConstantesFormes.SOMMET_COLOR_CONTOUR != telleCouleur)
		{
			ConstantesFormes.SOMMET_COLOR_CONTOUR = telleCouleur;
			maj_all_arbre();
		}
	}
	
	/**
	 * Retourne la couleur attribue aux contours des sommets
	 * @return la couleur des contours
	 */
	public Color getColorContourSommets()
	{
		return ConstantesFormes.SOMMET_COLOR_CONTOUR;
	}	
	
	/**
	 * Change la couleur des aretes
	 * @param telleCouleur la nouvelle couleur de contour des sommets
	 */
	public void majColorColorAretes(Color telleCouleur)
	{
		if(ConstantesFormes.ARETE_COLOR != telleCouleur)
		{
			ConstantesFormes.ARETE_COLOR = telleCouleur;
			maj_all_arbre();
			
	 		int nb = sonPanelCartes.getComponentCount();
	 	
		 	for(int i=0 ; i<nb; i++)
		 	{
	 			((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getSonArbre().majColorArete(telleCouleur);
	 			
	 			if(((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getCopieArbre()!=null)
				{
					((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getCopieArbre().majColorArete(telleCouleur);
				}
			}
						
		}
	}

	/**
	 * Retourne la couleur attribue aux aretes
	 * @return la couleur des aretes
	 */
	public Color getColorAretes()
	{
		return ConstantesFormes.ARETE_COLOR;
	}	
		
	/** 
	 * Change la couleur du texte des sommets
	 * @param telleCouleur la nouvelle couleur
	 */
	public void majColorTexteSommets(Color telleCouleur)
	{
		if(ConstantesFormes.SOMMET_COLOR_TEXTE != telleCouleur)
		{		
			ConstantesFormes.SOMMET_COLOR_TEXTE = telleCouleur;
		
	 		int nb = sonPanelCartes.getComponentCount();
	 	
		 	for(int i=0 ; i<nb; i++)
		 	{
	 			((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getSonArbre().majColorTexte(telleCouleur);
	 			
	 			if(((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getCopieArbre()!=null)
				{
					((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getCopieArbre().majColorTexte(telleCouleur);
				}
	 			
			}
		}
	}
	
	/**
	 * Retourne la couleur attribue aux texte des sommets
	 * @return la couleur des textes
	 */
	public Color getColorTexteSommets()
	{
		return ConstantesFormes.SOMMET_COLOR_TEXTE;
	}	
			
	/**
	 * Change le diamtre des sommets
	 * @param telDiametre le nouveau diamtre
	 */
	public void majDiametreSommets(double telDiametre)
	{
		if(ConstantesFormes.LARGEUR_ELL != telDiametre)
		{
			ConstantesFormes.LARGEUR_ELL = telDiametre;
			
			int nb = sonPanelCartes.getComponentCount();
	 	
	 		for(int i=0 ; i<nb; i++)
	 		{
	 			((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getSonArbre().majDiametreSommets(telDiametre);
	 			((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getSonArbre().maj_x_y();
	 			
	 			if(((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getCopieArbre()!=null)
				{
					((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getCopieArbre().majDiametreSommets(telDiametre);
					((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getCopieArbre().maj_x_y();
				}
	 			
	 			((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().repaint();
			}
		}
	}
	
	/**
	 * Retourne le diamtre de sommets
	 * @return la couleur des contours
	 */
	public double getDiametreSommets()
	{
		return ConstantesFormes.LARGEUR_ELL;
	}	
		
	/**
	 * Met  jour tous les arbres
	 */
	public void maj_all_arbre()
	{
		int nb = sonPanelCartes.getComponentCount();
	 	for(int i=0 ; i<nb; i++)
	 	{
			((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getSonArbre().maj_x_y();
			
			if(((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getCopieArbre()!=null)
				((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getCopieArbre().maj_x_y();
			
			((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().repaint();
		}		
	}
	
	/**
	 * Sauvegarde l'arbre courant
	 * @param telFichier le fichier dans lequel on sauvegarde l'arbre
	 */	
	public void sauvegarderCourant(File telFichier)
	{
		if(getCurrentArbreGraphique()!=null)
		{
			Flux leFlux=null;
			
			if(!telFichier.getPath().toLowerCase().endsWith(".leda"))
				leFlux=new Flux(telFichier.getPath()+".leda");
			else
				leFlux=new Flux(telFichier.getPath());
				
			leFlux.ecrire(Conversion.graphicToDonnees(getCurrentArbreGraphique()));	
		}
	}

	/**
	 * Charge un arbre
	 * @param telFichier le fichier  charger
	 */
	public void chargerNouveau(File telFichier)
	{
		ABP tmp;
		Flux leFlux=new Flux(telFichier.getPath());
		if ((tmp = leFlux.lire ()) != null) {
			Conversion.donneeToGraphic(leFlux.lire());
			addNewPanel(Conversion.donneeToGraphic(leFlux.lire()));
		}
	}
	
	/**
	 * Sauvegarder tout
	 * @param telDossier le dossier
	 */
	public void sauvegarderTout(File telDossier)
	{
		Vector lesABP = new Vector();
		
		if(sonPanelCartes.getComponentCount()>0)
		{
			for(int i=0; i<sonPanelCartes.getComponentCount(); i++)
			{
				UnArbreGraphique telArbre = ((UneScrollbar)sonPanelCartes.getComponent(i)).getSonPanel().getSonArbre();	
				lesABP.add(Conversion.graphicToDonnees(telArbre));
			}
			
			boolean t=new Usine().toutEcrire(lesABP, telDossier.getPath());
			if(t)
				JOptionPane.showMessageDialog(this, "Les arbres ont ete correctement enregistres");
			else
				JOptionPane.showMessageDialog(this, "Les arbres ont ete correctement enregistres", "Erreur !", JOptionPane.ERROR_MESSAGE);
		}	
	}
	
	/**
	 * Charger tout
	 * @param telDossier le dossier qui contient les fichiers  charger
	 */
	 public void chargerTout(File telDossier)
	 {
	 	Vector lesABP = new Usine().toutLire(telDossier.getPath());
	 	if(lesABP != null && lesABP.size() > 0)
	 	{
	 		for(int i=0; i<lesABP.size(); i++)
	 		{
	 			addNewPanel(Conversion.donneeToGraphic((ABP)lesABP.get(i)));	
	 		}
	 	}	
	 }
	
	/**
	 * Ferme tout les panels
	 */
	public void fermerTout()
	{
		sonPanelCartes.removeAll();
		sonPanelCartes.updateUI();
		sonPanelCommandes.majLabelNbArbre(0);
		sonPanelCommandes.activeBouton();		
	}

	/**
	 * Ajoute un arbre de hauteur h gnr alatoirement
	 * @param telleHauteur la hauteur de l'arbre
	 */
	public void genAleaH(int telleHauteur)
	{
		new UnThread("unh", this, telleHauteur);
	}

	/**
	 * Ajoute un arbre de n noeuds gnr alatoirement
	 * @param telleHauteur la hauteur de l'arbre
	 */
	public void genAleaT(int telNbNoeud)
	{		
		new UnThread("unn", this, telNbNoeud);
	}
	

	/**
	 * Ajoute tous les arbres de hauteur h gnr alatoirement
	 * @param telleHauteur la hauteur des arbres
	 */
	public void genTousH(int telleHauteur)
	{
		new UnThread("toush", this, telleHauteur);
	}
	/**
	 * Ajoute tous les arbres ayant le nombre de noeuds spcifis
	 * @param telleHauteur la hauteur des arbres
	 */
	public void genTousT(int telNbNoeud)
	{
		new UnThread("tousn", this, telNbNoeud);
	}
		
}

class UneScrollbar extends JScrollPane
{
	private UnPanelDessin sonPanelDessin;

	public UneScrollbar(Component view)
	{
		super(view);
		sonPanelDessin = (UnPanelDessin)view;
	}
	
	public UnPanelDessin getSonPanel()
	{
		return sonPanelDessin;
	}
}

class UnThread extends Thread
{
	private String sonAlgo = null;
	private UnPanelDessinBase sonPanelBase = null;
	private int sonNb;

	public UnThread(String telAlgo, UnPanelDessinBase telPanel, int telNb)
	{
		sonNb = telNb;
		sonAlgo = telAlgo;
		sonPanelBase = telPanel;
		
		this.start();	
	}
	
	public void run()
	{
		//try
		//{
			if(sonAlgo.equals("toush"))
			{
				Vector lesABP = new Usine().genTousH(sonNb);
				for(int i = 0; i< lesABP.size(); i++)
					sonPanelBase.addNewPanel(Conversion.donneeToGraphic((ABP)lesABP.get(i)));
				
				return;	
			}
			
			if(sonAlgo.equals("tousn"))
			{
				Vector lesABP = new Usine().genTousT(sonNb);
			
				for(int i = 0; i< lesABP.size(); i++)
					sonPanelBase.addNewPanel(Conversion.donneeToGraphic((ABP)lesABP.get(i)));

				return;	
			}

			if(sonAlgo.equals("unh"))
			{
				sonPanelBase.addNewPanel(Conversion.donneeToGraphic(new Usine().genAleaH(sonNb)));
				return;	
			}

			if(sonAlgo.equals("unn"))
			{
				sonPanelBase.addNewPanel(Conversion.donneeToGraphic(new Usine().genAleaT(sonNb)));
				return;	
			}
		//}
		//catch(InterruptedException e)
		//{
		//	JOptionPane.showMessageDialog(sonPanelBase, "Erreur de Thread !");	
		//}
	
		
	}	
	
}
