package moduleexecution;

import java.awt.*;
import javax.swing.JToolBar;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;
import java.lang.*;

import structuresgraphique.*;
import structuresdonnees.*;

/* ----------------------------------------------------------- */
/* Classe Implmentant la barre d'outils du module Execution   */
/* ----------------------------------------------------------- */

public class BarreOutilsExecution extends JToolBar implements ActionListener {

	private JButton sonBoutonEditer = new JButton(new ImageIcon(Constantes.IMG_TOOLBAR_EDIT));
	private JButton sonBoutonExecution = new JButton(new ImageIcon(Constantes.IMG_TOOLBAR_RUNP));
	private JButton sonBoutonExecutionP = new JButton(new ImageIcon(Constantes.IMG_TOOLBAR_RUN));
	private JButton sonBoutonStop = new JButton(new ImageIcon(Constantes.IMG_TOOLBAR_STOP));
	private JButton sonBoutonPrevOrd = new JButton(new ImageIcon(Constantes.IMG_TOOLBAR_PREV_ORD));
	private JButton sonBoutonNextOrd = new JButton(new ImageIcon(Constantes.IMG_TOOLBAR_NEXT_ORD));
	private JButton sonBoutonInfos = new JButton(new ImageIcon(Constantes.IMG_TOOLBAR_INFOS));
	
	private PanneauExecution sonModuleExecution;
	
	private boolean pasapas;
	
	private JComboBox saListe = new JComboBox(Constantes.TOOLBAR_FONCTIONS);
	private JScrollPane sonScrollPaneListe = new JScrollPane(saListe);
	

	public BarreOutilsExecution(PanneauExecution telPE) {
		
		sonModuleExecution = telPE;
		/* Les boutons de la Tool Bar */
		sonBoutonEditer.setToolTipText(Constantes.TIP_TOOLBAR_EDIT);
		sonBoutonExecution.setToolTipText(Constantes.TIP_TOOLBAR_RUN);
		sonBoutonExecutionP.setToolTipText(Constantes.TIP_TOOLBAR_RUNP);
		sonBoutonStop.setToolTipText(Constantes.TIP_TOOLBAR_STOP);
		sonBoutonStop.setEnabled(false);
		sonBoutonPrevOrd.setToolTipText(Constantes.TIP_TOOLBAR_PREV_ORD);
		sonBoutonPrevOrd.setEnabled(false);
		sonBoutonNextOrd.setToolTipText(Constantes.TIP_TOOLBAR_NEXT_ORD);
		sonBoutonNextOrd.setEnabled(false);
		sonBoutonInfos.setToolTipText(Constantes.TIP_TOOLBAR_INFOS);
		
		sonBoutonEditer.addActionListener(this);
		sonBoutonExecution.addActionListener(this);
		sonBoutonExecutionP.addActionListener(this);
		sonBoutonStop.addActionListener(this);
		sonBoutonPrevOrd.addActionListener(this);
		sonBoutonNextOrd.addActionListener(this);
		sonBoutonInfos.addActionListener(this);
		
		add(sonBoutonExecution);
		add(sonBoutonExecutionP);
		add(sonBoutonStop);
		
		setFloatable(false);
		
		/* La liste droulante */
		//saListe.setVisibleRowCount(1);
		saListe.setSelectedIndex(0);
		//saListe.setFont( new Font ("Arial",0,12));
		
		//add(sonScrollPaneListe);
		add(saListe);
		
		/* Le reste */
		add(sonBoutonPrevOrd);
		add(sonBoutonNextOrd);
		
		add(sonBoutonInfos);
		add(new JLabel("                                          "));
				
	}
	
	/**
	 * @see ActionListener#actionPerformed(ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		
		
		/* Clic sur bouton Infos */
		if (e.getSource() == sonBoutonInfos) {
			if (sonModuleExecution.getPanneauAffichage().getPanneauInfosTrace().isVisible()) sonModuleExecution.getActions().action_MasquerPanneauRapport();			
			else sonModuleExecution.getActions().action_AfficherPanneauRapport();	
		}
		/* Clic sur bouton Execution Pas  Pas */
		if (e.getSource() == sonBoutonExecutionP) {
			pasapas = true;
			int numAlgo = saListe.getSelectedIndex();
			
			sonBoutonStop.setEnabled(true);
			sonBoutonExecution.setEnabled(false);
			sonBoutonExecutionP.setEnabled(false);
			sonModuleExecution.getPanneauAffichage().resetInfos();
			sonModuleExecution.getActions().action_lancerExecutionAlgo(numAlgo);	
			
		}
		
		/* Clic sur bouton Executer Algo */
		if (e.getSource() == sonBoutonExecution) {
			pasapas = false;
			int numAlgo = saListe.getSelectedIndex();
			
			sonBoutonStop.setEnabled(true);
			sonBoutonExecution.setEnabled(false);
			sonBoutonExecutionP.setEnabled(false);
			sonBoutonPrevOrd.setEnabled(false);
			sonBoutonNextOrd.setEnabled(false);
			
			sonModuleExecution.getPanneauAffichage().resetInfos();
			sonModuleExecution.getActions().action_lancerExecutionAlgo(numAlgo);	
			
		}
		/* Clic sur bouton Stop */
		if (e.getSource() == sonBoutonStop)
		{
			sonModuleExecution.getActions().action_stopperExecutionAlgo();
			sonModuleExecution.getPanneauAffichage().getPanelArbre().getArbre().maj_x_y();
			sonModuleExecution.getPanneauAffichage().getPanelArbre().repaint();
			sonBoutonExecution.setEnabled(true);
			sonBoutonExecutionP.setEnabled(true);
			sonBoutonStop.setEnabled(false);
			
		}
		/* Clic sur bouton Next */
		if (e.getSource() == sonBoutonNextOrd) {
			try {
				int i=sonModuleExecution.getPanneauAffichage().getPanelCourbe().getIndiceOrdonnancement();
				i++;
			
				sonModuleExecution.getPanneauAffichage().getPanelCourbe().setIndiceOrdonnancement(i);
				sonModuleExecution.getActions().action_miseAJourOrdonnancement();
			
				/* Si Pas a Pas, alors dessiner sur l'arbre */
				
		
				
				if (i > 0) activerPrev(true) ;
				if ( i == sonModuleExecution.getPanneauAffichage().getPanelCourbe().getOrdonnancement().size()-1) {
					activerNext(false);
				}
			}
			catch(Exception ex) {;}
		}
		/* Clic sur bouton Prev */
		if (e.getSource() == sonBoutonPrevOrd) {
			int i=sonModuleExecution.getPanneauAffichage().getPanelCourbe().getIndiceOrdonnancement();
			i--;	
			
			
			sonModuleExecution.getPanneauAffichage().getPanelCourbe().setIndiceOrdonnancement(i);
			sonModuleExecution.getActions().action_miseAJourOrdonnancement();
			
			
			activerNext(true) ;
			if ( i == 0) {activerPrev(false);}
			
		}
		
	}


	public void activerPrev(boolean b) { sonBoutonPrevOrd.setEnabled(b);}
	public void activerNext(boolean b) { sonBoutonNextOrd.setEnabled(b);}
	public void activerExecution() { sonBoutonStop.setEnabled(false); sonBoutonExecution.setEnabled(true);sonBoutonExecutionP.setEnabled(true);}
	public void activerStop () { sonBoutonStop.setEnabled (true); }
	public boolean isPasapas() {return pasapas;}	
}
