package moduleexecution;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

import modulecreation.UnPanelDessinBase;
//import ihm.Constantes;

/* Classe matrialisant le panneau d'affichage sur lequels l'Arbre va s'afficher */
public class PanneauAffichage extends JPanel {

	private JPanel sonPanneauArbre = new JPanel();
	private JTabbedPane sonPanelArbreOnglet = new JTabbedPane();
	private JPanel sonPanneauInfosTrace = new JPanel();
	private JTextArea sonTextAreaInfos = new JTextArea(30,20);

    UnPanelExecutionArbre upea=new UnPanelExecutionArbre();
    UnPanelExecutionCourbe upec=new UnPanelExecutionCourbe();
	
	/* Accesseurs */
	public JPanel getPanneauInfosTrace() {return sonPanneauInfosTrace;}
    public UnPanelExecutionArbre getPanelArbre() {return upea;}
    public UnPanelExecutionCourbe getPanelCourbe() {return upec;}
    public JTextArea getZoneRapport() {return sonTextAreaInfos;}
	
	/* Constructeur */
	public PanneauAffichage(PanneauExecution telPE) {
		
		setLayout(new BorderLayout());
		
		/* Le panneau d'affichage ABR - Compos de 2 onglets arbre et courbe */
		creerPanneauArbre();
		
		/* Le panneau d'affichage des informations d'execution */
		 
		sonTextAreaInfos.setBackground(new Color(205,205,205));
		sonTextAreaInfos.setEditable(false);
		
		sonTextAreaInfos.setFont(ihm.Constantes.POLICE);
		TitledBorder bordure = new TitledBorder(Constantes.LIBELLE_PANNEAU_AFFICHAGE_RAPPORT);
			bordure.setTitleFont(ihm.Constantes.POLICE);
		sonPanneauInfosTrace.setBorder(bordure);
		
		JScrollPane barreZoneTexte = new JScrollPane(sonTextAreaInfos,JScrollPane.VERTICAL_SCROLLBAR_NEVER,JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		//sonPanneauInfosTrace.add(sonTextAreaInfos);
		sonPanneauInfosTrace.add(barreZoneTexte);
		add(sonPanneauInfosTrace, BorderLayout.EAST);
		validate();
	}
	
	/* --------------------------------------------------------------- */
	/* Cr un panneau o un arbre et ses infos pourront etre affichs */
	/* --------------------------------------------------------------- */
	public void creerPanneauArbre() {
		TitledBorder bordure = new TitledBorder(Constantes.LIBELLE_PANNEAU_AFFICHAGE_TITRE);
			bordure.setTitleFont(ihm.Constantes.POLICE);
		sonPanneauArbre.setLayout(new GridLayout(1,1));
		sonPanneauArbre.setBorder(bordure);
		sonPanelArbreOnglet.setFont(ihm.Constantes.POLICE);

        JScrollPane barreArbre = new JScrollPane(upea,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        sonPanelArbreOnglet.add(barreArbre,Constantes.LIBELLE_PANNEAU_AFFICHAGE_ARBRE);// celui d'etienne
        JScrollPane barreCourbe =new JScrollPane(upec,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        sonPanelArbreOnglet.add(barreCourbe,Constantes.LIBELLE_PANNEAU_AFFICHAGE_COURBE);// celui d'etienne
		
		sonPanneauArbre.add(sonPanelArbreOnglet);
		
		sonPanneauArbre.validate();
		add(sonPanneauArbre, BorderLayout.CENTER);
		validate();
		
	} // fin de creerPanneauArbre
	
	/* -------------------------------------------------------------- */
	/* Mthode qui affiche une infos sur le panneau prvu a cet effet */
	/* -------------------------------------------------------------- */
	public void afficherInfos(String telInfos) {
		sonTextAreaInfos.append(telInfos+"\n");
	} // fin de afficherInfos
	
	/* -------------------------------------------------------------- */
	/* Mthode qui efface le contenu du rapport 			  */
	/* -------------------------------------------------------------- */
	public void resetInfos() {
		sonTextAreaInfos.setText("");
	} // fin de resetInfos
	
	
}

