package moduleexecution;

import structuresgraphique.UneCourbe;

import javax.swing.*;
import java.awt.*;
import java.util.Vector;


/**
 * Cette classe reprsente un panel gnrique dans lequel
 * peut tre facilement dessin une courbe.
 * remarquons qu'aucun evenement est disponible sur ce panel
 */
public class UnPanelExecutionCourbe extends JPanel
{
	protected UneCourbe telleCourbe=null;
	private Vector ordonnancement;
	private int indiceOrdonnancement;
	private boolean sonEtatAntiAlias=true;
	

	public Vector getOrdonnancement() {return ordonnancement;}
	public void setOrdonnancement(Vector telOrdo) {ordonnancement = telOrdo;}
	
	public int getIndiceOrdonnancement() {return indiceOrdonnancement;}
	public void setIndiceOrdonnancement(int n) {indiceOrdonnancement = n;}
	
	
	
	
    // constructeur:
    public UnPanelExecutionCourbe()
    {
     // couleur a recuperer dans parametrages!!
     setBackground(Color.white);
     setPreferredSize(new Dimension(600,600));
     ordonnancement = null;
    }
	
    // defini les attributs de classe:

    public void setCourbe(UneCourbe laCourbe)
    {
    	telleCourbe=laCourbe;
    	repaint();
    }

	/**
	 * Dessine les composants
	 * @param g le contexte graphique
	 */
	public void paintComponent(Graphics g)
	{
  		super.paintComponent(g);
		Graphics2D g2d = (Graphics2D)g;
		
		// Activation de l'antialisating 
		if(sonEtatAntiAlias)
			g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
		else
			g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF);			
		
		
		// Dessine la courbe
		if(telleCourbe!=null){telleCourbe.dessineCourbe(g2d);}
	}

	/**
	 * Pour eviter que l'ecran soit effac  chaque repaint()
	 * @param g le contexte graphique
	 */
	public void update(Graphics g) 
	{	
		paint(g);
	}
	
	public void setAntiAlias(boolean telEtat)
	{
		sonEtatAntiAlias=telEtat;
		repaint();
	}
}


