package structuresdonnees;

import java.io.*;
import java.util.Vector;

public class Usine
{
	/* nom donn au fichier contenant la version du programme  afficher.
	 * Cela pourrait servir aussi de readme car il est possible d'ajouter du
	 * texte  la suite du "logo" vu que l'afficheur s'arrte  la premire
	 * ligne vide */
	private static final String nomVersion = "structuresdonnees/README";
	
	/* gnre tous les arbres de hauteur 'hauteur' */
	public Vector genTousH (int h)
	{
		h++;
		gen tmp = new gen ();
		return tmp.genHauteur(h);
	}

	/* permet de grer le dmarrage et les arrts des algos */
	private static boolean go_flag = true;
	public static void arret () { go_flag = false; }
	public static void debut () { go_flag = true; }
	public static boolean continu () { return go_flag; }
		
	/* gnre tous les arbres contenant nbrNoeud */
	public Vector genTousT (int nbrNoeud)
	{
		gen tmp = new gen ();
		return tmp.genNoeud(nbrNoeud);
	}
	
	/* gnre un arbre alatoirement en fonction de sa hauteur */
	public ABP genAleaH (int hauteur)
	{
		/* la hauteur relle est un cran au dessus de celle utilise
		 * par l'algo, donc il faut rtablir la vrit */
		hauteur++;
		int [] tab = new int[(int)Math.pow(2,hauteur+1)] ;
		genA tmp = new genA ();
		tab = tmp.gen_Tab(tab, hauteur, -1) ;
		ABP a = new ABP(hauteur) ;
		for( int i=1 ; i<((int)Math.pow(2,hauteur+1)) ; i++ )
			if( tab[i]!=0 ) a.setNoeud(i) ;
		a.calculStrahler (1);
		return a ;
	}
		
	/* gnre un arbre alatoirement en fonction de son nombre max de noeud */
	public ABP genAleaT (int nbrNoeud)
	{
		int i = 0 ;
		genA tmp = new genA ();
		/* Seuls les nombres de noeuds impairs sont possibles dans un ABP */
		if( (nbrNoeud % 2) == 0 ) return null ;
		/* hauteur = hauteur max en fonction du nbrNoeud */
		int hauteur = (nbrNoeud+1)/2 ;
		ABP a = new ABP(hauteur) ;				
		int [] tab = new int[(int)Math.pow(2,hauteur)] ;
		tab = tmp.gen_Tab(tab, -1, nbrNoeud) ;
		for( i=1 ; i<tab.length ; i++) 
			if( tab[i] != 0 ) a.setNoeud(i) ;
		a.setHauteur ();
		a.calculStrahler (1);
		return a ;
	}
		
	/* gnre tous les ordonnancements valides */
	public  Vector genOrdoT (ABP arbre)
	{
		Vector feuille = new Vector();
		ordoT tmp = new ordoT ();
		int nbNoeud = arbre.getFeuille(feuille);
		debut ();
		return tmp.Ordo(feuille, nbNoeud, arbre, false);
	}
	/* gnre un ordonnancement alatoirement */
	public Ordonnancement genOrdoA (ABP arbre)
	{
		ordoA tmp = new ordoA ();
		debut ();
		return tmp.ordoAlea(arbre);
	}
	/* gnre tous les ordonnancements optimaux localement */
	public Vector genOrdoOptLocal (ABP arbre)
	{
		ordoOptT tmp = new ordoOptT ();
		arbre.calculStrahler (1);
		debut ();
		return tmp.ordo (arbre);
	}
	/* gnre tous les ordonnancements optimaux globalement */
	public Vector genOrdoOptGlob (ABP arbre)
	{
		Vector feuille = new Vector ();
		ordoT tmp = new ordoT ();
		int nbNoeud = arbre.getFeuille (feuille);
		debut ();
		return tmp.Ordo (feuille, nbNoeud, arbre, true);
	}
	/* cette fonction lit un fichier leda et retourne l'arbre correspondant */
	public ABP lireFichier (String nomfichier)
	{
		Flux fichier = new Flux (nomfichier);
		return fichier.lire ();
	}

	/* cette fonction vrifie que le fichier sur lequel on veut crire
	 * n'est pas le fichier "version" */
	private boolean verifVersion (String fichier)
	{
		fichier = fichier.trim ();
		if (fichier.equals (nomVersion)) {
			affiche_erreur ("Eh ! Tu veux pas ecraser le superbe fichier de version tout de meme !! grrr...");
			return false;
		}
		return true;
	}
		
	/* cette fonction crit dans un fichier leda */
	public boolean ecrireFichier (ABP arbre, String nomfichier)
	{
		Flux fichier = new Flux (nomfichier);
		if (!verifVersion (nomfichier)) return false;
		return fichier.ecrire (arbre);
	}

	/* lit un "projet", c'est  dire tous les fichiers leda contenus
	 * contenus dans un rpertoire donn. Cela renvoi un vector d'ABP */
	public Vector toutLire (String nomRep)
	{
		File rep = new File (nomRep);
		int taille;
		Vector retour;
		File [] liste; /* liste de tous les fichiers du rpertoire */
		ABP tmp; /* va rcuprer les ABP avant de les stocker dans le
				  * vector */
		/* si le rpertoire n'est pas un rpertoire ... :) C'est pas bon */
		if (!rep.isDirectory ()) {
			affiche_erreur (nomRep + " n'est pas un repertoire");
			return null;
		}
		liste = rep.listFiles ();
		taille = liste.length;
		retour = new Vector ();
		/* on tente de lire tous les fichiers du rpertoire */
		for (int i = 0; i < taille; i++) {
			tmp = lireFichier (liste [i].getAbsolutePath ());
			/* si le fichier est un fichier leda */
			if (tmp != null) retour.addElement (tmp);
		}
		return retour;
	}
		
	/* crit un "projet" c'est  dire un Vector de noeuds dans un rpertoire
	 * avec #.leda comme nom de fichier */
	public boolean toutEcrire (Vector projet, String nomfichier)
	{
		File rep = new File (nomfichier);
		int taille;
		String fichier;
		if (rep.isFile ()) return false;
		/* si le rpertoire n'existe pas, on tente de le crer avec son
		 * arborescence */
		if (!rep.isDirectory ())
			if (!rep.mkdirs ()) {
				affiche_erreur ("Ne peut creer " + rep.getName ());
				return false;
			}
		if (projet == null) return false;
		taille = projet.size ();
		for (int i = 0; i < taille; i++) {
			fichier = nomfichier + "/" + i + ".leda";
			if (!ecrireFichier ((ABP) projet.elementAt (i), fichier))
				return false;
		}
		return true;
	}

	/* lance tous les algos en fonction des paramtres */
	public void lance_algos (String [] args)
	{
		Vector tmp = new Vector ();
		ABP arbre;
		if (args [0].equals ("ver")) {
			version ();
			return;
		}
		if (args [0].equals ("tah")) {
			tmp = genTousH (Integer.parseInt (args [1]));
		}
		if (args [0].equals ("tan")) {
			if (Integer.parseInt (args [1]) == 0) {
				affiche_erreur ("Un arbre avec 0 noeuds ? T'es un marrant toi !");
				return;
			}
			tmp = genTousT (Integer.parseInt (args [1]));
		}
		/* on crit dans le rpertoire */
		if (args [0].equals ("tah") || args [0].equals ("tan")) {
			toutEcrire (tmp, args [2]);
			return;
		}
			
		if (args [0].equals ("aah")) {
			ecrireFichier (genAleaH (Integer.parseInt (args [1])), args [2]);
			return ;
		}
		if (args [0].equals ("aan")) {
			if (Integer.parseInt (args [1]) == 0) {
				affiche_erreur ("Un arbre avec 0 noeuds ? T'es un marrant toi !");
				return;
			}
			ecrireFichier (genAleaT (Integer.parseInt (args [1])), args [2]);
			return;
		}
		if (args [0].equals ("tov")) {
			if ((arbre = lireFichier (args [1])) == null) return;
			genOrdoT (arbre);
			return;
		}
		if (args [0].equals ("aov")) {
			if ((arbre = lireFichier (args [1])) == null) return;
			genOrdoA (arbre);
			return;
		}
		if (args [0].equals ("too")) {
			if ((arbre = lireFichier (args [1])) == null) return;
			genOrdoOptLocal (arbre);
			return;
		}
		if (args [0].equals ("toO")) {
			if ((arbre = lireFichier (args [1])) == null) return;
			genOrdoOptGlob (arbre);
			return;
		}
	}

	/* petite fonction qui affiche les messages d'erreurs en rouge
	 * pour que a se voit bien :) */
	public static void affiche_erreur (String s)
	{
		System.out.println ("\033[30;31;3m" + s + "\033[m");
	}

	/* va vrifier que les arguments passs au programme sont corrects.
	Que le fichier est bien un fichier dans lequel on peut lire/crire.
	Que le rpertoire est bien un rpertoire dans lequel on peut crire.
	Que les arguments sont bien des arguments valides */
	public boolean verif_args (String [] args)
	{
		int tmp = -1;
		File fichier;
		if ((args.length > 0) && (args [0].equals ("ver")))
			return true;
		if (args.length < 2) return false;
		/* on tente de convertir le deuxime arguments en nombre.
		Si a ne l'est pas, on ne s'inquite pas tout de suite car cela
		peut etre un nom de fichier  lire pour les ordo. En revanche si 
		ce nombre est ngatif : on a affaire  un petit malin... */
		try {
			tmp = Integer.parseInt (args [1].trim ());
			if (tmp < 0) return false;
		}
		catch (NumberFormatException e) {}

		if (args [0].length () != 3) return false;
		/*  priori il s'agit des algos de gnration d'arbre */
		if (args [0].charAt(1) == 'a') {
			/* si l'argument des algos de gnration d'arbre n'est pas un
			nombre >= 0 c'est pas bon */
			if (tmp < 0) {
				affiche_erreur (tmp + " n'est pas un entier positif");
				return false;
			}
			/* si on a pas de nom de fichier on sort */
			if (args.length < 3) return false;
			fichier = new File (args [2]);
			/* si on demande  gnrer tous les arbres on doit vrifier
			que le rpertoire soit bien un rpertoire */
			if (args [0].charAt(0) == 't') {
				/* si c'est un fichier et non un rpertoire, c'est pas bon */
				if (fichier.isFile ()) {
					affiche_erreur (fichier.getName () + " n'est pas un repertoire");
					return false;
				}
				/* si le rpertoire n'existe pas on essaye de le crer avec 
				son arborescence si ncessaire */
				if (!fichier.isDirectory ())
					if (!fichier.mkdirs ()) {
						affiche_erreur ("Ne peut creer " + fichier.getName ());
						return false;
					}
			}
			else if (args [0].charAt(0) == 'a') {
				/* on aimerai bien ne pas craser le merveilleux boulot fait
				 * par notre graphiste :) */
				if (!verifVersion (fichier.getName ()))
					return false;
				/* si c'est pas un fichier, c'est pas bon */
				if (fichier.isDirectory ()) {
					affiche_erreur (fichier.getName () + " n'est pas un fichier");
					return false;
				}
				/* si on ne peut pas crire dedans, c'est pas bon non plus */
				if (fichier.isFile ())
					if (!fichier.canWrite ()) {
						affiche_erreur ("Ne peut pas ecrire dans " + fichier.getName ());
						return false;
					}
			}
			else return false;
			/* dans tous les cas on vrifie que la dernire lettre soit h ou hauteur
			ou n pour nombre de noeuds */
			/* ?ah */
			if (args [0].charAt(2) == 'h') return true;
			/* ?an */
			if (args [0].charAt(2) == 'n') return true;
			/* ta? */
			return false;
		}
		else if (args [0].charAt(1) == 'o') {
			fichier = new File (args [1]);
			/* on doit pouvoir lire dans ce fichier et que a ne soit pas un
			rpertoire */
			if (fichier.isDirectory ()) {
				affiche_erreur (fichier.getName () + " n'est pas un fichier");
				return false;
			}
			if (!fichier.canRead ()) {
				affiche_erreur ("Ne peut pas lire " + fichier.getName ());
				return false;
			}
			/* aov */
			if (args [0].equals ("aov")) return true;
			/* to? */
			if (args [0].charAt(0) == 't') {
				switch (args [0].charAt(2)) {
					case 'v' :;
					case 'o' :;
					case 'O' : break;
					default : return false;
				}
				return true;
			}
			/* dans tous les autres cas */
			return false;
		}
		return false;
	}

	/* jolie prsentation d'ABP Manipulator */
	public void version ()
	{
		File fichier = new File (nomVersion);
		FileReader lecteur;
		BufferedReader buffer;
		String ligne;
		if (!fichier.canRead ()) {
			affiche_erreur ("Ne peut ouvrir le fichier " + nomVersion);
			return;
		}
		try {
			lecteur = new  FileReader (fichier);
			buffer = new BufferedReader (lecteur);
			while (((ligne = buffer.readLine ()) != null) && 
					(ligne.length () > 0))
				System.out.println ("\033[30;32;5m" + ligne + "\033[m");
		}
		catch (IOException e) { affiche_erreur ("Erreur de lecture"); }
	}

	/* explique le fonctionnement du programme en ligne de commande */
	public void usage ()
	{
		System.out.println ("\n\t\t\033[30;32;3m*****************************\033[m");
		System.out.println ("\t\t\033[30;32;3m****** ABP manipulator ******\033[m");
		System.out.println ("\t\t\033[30;32;3m*****************************\033[m\n");
		System.out.println ("java Usine <arguments> [fichier/repertoire]\n");
		System.out.println ("\033[30;36;3marguments :\033[m");
		System.out.println ("Pour generer ...");
		System.out.println ("\033[30;31;3mtah\033[m : tous les arbres en fonction de la hauteur (argument suivant). Stocke dans repertoire/#.leda");
		System.out.println ("\033[30;31;3mtan\033[m : tous les arbres en fonction du nombre de noeuds (argument suivant). Stocke dans repertoire/#.leda");
		System.out.println ("\033[30;31;3maah\033[m : un arbre aleatoirement en fonction de la hauteur (argument suivant). Stocke dans fichier.");
		System.out.println ("\033[30;31;3maan\033[m : un arbre aleatoirement en fonction du nombre de noeuds (argument suivant). Stocke dans fichier.");
		System.out.println ("\033[30;31;3mtov\033[m : tous les ordonnancements valides de l'arbre lu dans fichier.");
		System.out.println ("\033[30;31;3maov\033[m : un ordonnancement aleatoirement de l'arbre du dans fichier.");
		System.out.println ("\033[30;31;3mtoo\033[m : tous les ordonnancements optimaux localement de l'arbre lu dans fichier.");
		System.out.println ("\033[30;31;3mtoO\033[m : tous les ordonnancements optimaux globalement de l'arbre lu dans fichier.");
		System.out.println ("\033[30;31;3mver\033[m : a propos");
	}
	
	public static void main (String [] args)
	{
		Usine agaz = new Usine ();
		if (!agaz.verif_args (args)) {
			agaz.usage ();
			System.exit (1);
		}
		agaz.lance_algos (args);
	}
}
