package structuresgraphique;

import java.awt.*;

import structuresdonnees.Ordonnancement;
import structuresdonnees.ABP;
import parametres.Parametrages;

/**
 * Cette classe rprsente la structure d'une courbe mais
 * spcialis pour tre affich dans une interface graphique
 */
public class UneCourbe
{
	private Ordonnancement unOrdo=null;
    private ABP sonArbre=null;
    private int L,H; //largeur et hauteur du panel pour affichage

	/**
	 * Pour construire UneCourbe
	 */
	public UneCourbe(Ordonnancement unOrdo,ABP sonArbre, int L,int H)
	{	
        this.unOrdo=unOrdo;
        this.sonArbre=sonArbre;
        this.L=L;
        this.H=H;
	}

	/**
	 * Dessine la courbe
	 * @param g2d le contexte d'affichage
	 */	
	public void dessineCourbe(Graphics2D g2d)
	{
     // dessine les axes:
     g2d.setColor(Color.black);
     // abcisse:
     g2d.drawLine(100,H-99,L-200,H-99);
     g2d.drawLine(100,H-100,L-200,H-100);
     flecheAbcisse(g2d,L-204,H-100);
     // ordonne:
     g2d.drawLine(99,H-100,99,100);
     g2d.drawLine(100,H-100,100,100);
     flecheOrdonnes(g2d,99,105);

     g2d.drawString("0",90,H-97);

     // suite du dessin si courbe a dessiner:
     if(unOrdo!=null && sonArbre!=null)
    {

     // remplissage de l'abcisse:
     g2d.drawString(ConstantesFormes.TITRE_COURBE_ABCISSE,L-180,H-95);
     int margeA=(L-300)/(unOrdo.getEtape().length+1);
     int niveauA=100;
     for(int i=0;i<unOrdo.getEtape().length;i++)
     {
      niveauA+=margeA;
      g2d.drawLine(niveauA,H-95,niveauA,H-105);
      //String NomNoeud="N"+sonArbre.getObjNoeud(unOrdo.getIndice(i));
      
      String NomNoeud="N"+unOrdo.getIndice(i);
      
      // Utiliser etape[i][0] pluto ke sonArbre ???
//////String NomNoeud="no"+sonArbre.getObjNoeud(unOrdo.getIndice(i)).id;
      g2d.drawString(NomNoeud,niveauA-7,H-80);
	 }
    // remplissage de l'ordonne:
    g2d.drawString(ConstantesFormes.TITRE_COURBE_ORDONNEE,70,90);
    int ConsoMax=ConsommationMax(unOrdo.getEtape());
    int margeO=(H-200)/(ConsoMax+1);
    int niveauO=H-100;
    for(int i=1;i<=ConsoMax;i++)
    {
     niveauO-=margeO;
     g2d.drawLine(95,niveauO,105,niveauO);
     g2d.drawString(""+i,80,niveauO+3);
    }
    // dessin de la courbe:
   	g2d.setColor(Parametrages.getCoulCourbe());

    int exX=100+margeA;
    int exY=(H-100)-(margeO*unOrdo.getEtape()[0][1]);
    int newX=100;
    int newY=0;
    for(int i=0;i<unOrdo.getEtape().length;i++)
    {
     newX+=margeA;
     newY=(H-100)-(margeO*unOrdo.getEtape()[i][1]);
     g2d.drawLine(exX,exY,newX,newY);
     exX=newX;
     exY=newY;
    }
   }
   }

   // dessine la fleche des abcisses:
   public void flecheAbcisse(Graphics2D g2d,int X,int Y)
   {
    for(int i=0;i<=4;i++)
    {g2d.drawLine(X+i,Y-(4-i),X+i,Y+(4-i)+1);}
   }

   // dessine la fleche des abcisses:
   public void flecheOrdonnes(Graphics2D g2d,int X,int Y)
   {
    for(int i=0;i<=4;i++)
    {g2d.drawLine(X-(5-i),Y-i,X+(5-i)+1,Y-i);}
   }

    /**
     * retourne la consommation maximum d'un ordonnancement
     */
    public int ConsommationMax(int[][] ordo)
    {
     int reponse=0;
     for(int i=0;i<ordo.length;i++)
     {
      if(ordo[i][1]>reponse)
      {
       reponse=ordo[i][1];
      }
     }
     return reponse;
    }
}

